// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SoftwarePackageCreateReader is a Reader for the SoftwarePackageCreate structure.
type SoftwarePackageCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SoftwarePackageCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSoftwarePackageCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSoftwarePackageCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSoftwarePackageCreateAccepted creates a SoftwarePackageCreateAccepted with default headers values
func NewSoftwarePackageCreateAccepted() *SoftwarePackageCreateAccepted {
	return &SoftwarePackageCreateAccepted{}
}

/*
SoftwarePackageCreateAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SoftwarePackageCreateAccepted struct {

	/* Useful for tracking the resource location
	 */
	Location string

	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this software package create accepted response has a 2xx status code
func (o *SoftwarePackageCreateAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this software package create accepted response has a 3xx status code
func (o *SoftwarePackageCreateAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this software package create accepted response has a 4xx status code
func (o *SoftwarePackageCreateAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this software package create accepted response has a 5xx status code
func (o *SoftwarePackageCreateAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this software package create accepted response a status code equal to that given
func (o *SoftwarePackageCreateAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SoftwarePackageCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /cluster/software/download][%d] softwarePackageCreateAccepted  %+v", 202, o.Payload)
}

func (o *SoftwarePackageCreateAccepted) String() string {
	return fmt.Sprintf("[POST /cluster/software/download][%d] softwarePackageCreateAccepted  %+v", 202, o.Payload)
}

func (o *SoftwarePackageCreateAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SoftwarePackageCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSoftwarePackageCreateDefault creates a SoftwarePackageCreateDefault with default headers values
func NewSoftwarePackageCreateDefault(code int) *SoftwarePackageCreateDefault {
	return &SoftwarePackageCreateDefault{
		_statusCode: code,
	}
}

/*
SoftwarePackageCreateDefault describes a response with status code -1, with default header values.

Error
*/
type SoftwarePackageCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the software package create default response
func (o *SoftwarePackageCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this software package create default response has a 2xx status code
func (o *SoftwarePackageCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this software package create default response has a 3xx status code
func (o *SoftwarePackageCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this software package create default response has a 4xx status code
func (o *SoftwarePackageCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this software package create default response has a 5xx status code
func (o *SoftwarePackageCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this software package create default response a status code equal to that given
func (o *SoftwarePackageCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SoftwarePackageCreateDefault) Error() string {
	return fmt.Sprintf("[POST /cluster/software/download][%d] software_package_create default  %+v", o._statusCode, o.Payload)
}

func (o *SoftwarePackageCreateDefault) String() string {
	return fmt.Sprintf("[POST /cluster/software/download][%d] software_package_create default  %+v", o._statusCode, o.Payload)
}

func (o *SoftwarePackageCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SoftwarePackageCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
