// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// ActiveDirectoryModifyReader is a Reader for the ActiveDirectoryModify structure.
type ActiveDirectoryModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ActiveDirectoryModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewActiveDirectoryModifyOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewActiveDirectoryModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewActiveDirectoryModifyOK creates a ActiveDirectoryModifyOK with default headers values
func NewActiveDirectoryModifyOK() *ActiveDirectoryModifyOK {
	return &ActiveDirectoryModifyOK{}
}

/*
ActiveDirectoryModifyOK describes a response with status code 200, with default header values.

OK
*/
type ActiveDirectoryModifyOK struct {
	Payload *models.ActiveDirectory
}

// IsSuccess returns true when this active directory modify o k response has a 2xx status code
func (o *ActiveDirectoryModifyOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this active directory modify o k response has a 3xx status code
func (o *ActiveDirectoryModifyOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this active directory modify o k response has a 4xx status code
func (o *ActiveDirectoryModifyOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this active directory modify o k response has a 5xx status code
func (o *ActiveDirectoryModifyOK) IsServerError() bool {
	return false
}

// IsCode returns true when this active directory modify o k response a status code equal to that given
func (o *ActiveDirectoryModifyOK) IsCode(code int) bool {
	return code == 200
}

func (o *ActiveDirectoryModifyOK) Error() string {
	return fmt.Sprintf("[PATCH /protocols/active-directory/{svm.uuid}][%d] activeDirectoryModifyOK  %+v", 200, o.Payload)
}

func (o *ActiveDirectoryModifyOK) String() string {
	return fmt.Sprintf("[PATCH /protocols/active-directory/{svm.uuid}][%d] activeDirectoryModifyOK  %+v", 200, o.Payload)
}

func (o *ActiveDirectoryModifyOK) GetPayload() *models.ActiveDirectory {
	return o.Payload
}

func (o *ActiveDirectoryModifyOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ActiveDirectory)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewActiveDirectoryModifyDefault creates a ActiveDirectoryModifyDefault with default headers values
func NewActiveDirectoryModifyDefault(code int) *ActiveDirectoryModifyDefault {
	return &ActiveDirectoryModifyDefault{
		_statusCode: code,
	}
}

/*
	ActiveDirectoryModifyDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 656464 | Failed to modify the Active Directory machine account. Reason: Invalid Credentials. |
| 656465 | Failed to modify the Active Directory machine account. Reason: Account with same name already exists. |
| 656466 | Failed to modify the Active Directory machine account. Reason: Domain Controller is not reachable or does not exist. |
| 656467 | Failed to modify the Active Directory machine account. Reason: Organizational-Unit not found. |
*/
type ActiveDirectoryModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the active directory modify default response
func (o *ActiveDirectoryModifyDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this active directory modify default response has a 2xx status code
func (o *ActiveDirectoryModifyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this active directory modify default response has a 3xx status code
func (o *ActiveDirectoryModifyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this active directory modify default response has a 4xx status code
func (o *ActiveDirectoryModifyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this active directory modify default response has a 5xx status code
func (o *ActiveDirectoryModifyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this active directory modify default response a status code equal to that given
func (o *ActiveDirectoryModifyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *ActiveDirectoryModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /protocols/active-directory/{svm.uuid}][%d] active_directory_modify default  %+v", o._statusCode, o.Payload)
}

func (o *ActiveDirectoryModifyDefault) String() string {
	return fmt.Sprintf("[PATCH /protocols/active-directory/{svm.uuid}][%d] active_directory_modify default  %+v", o._statusCode, o.Payload)
}

func (o *ActiveDirectoryModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ActiveDirectoryModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
