// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewActiveDirectoryPreferredDcDeleteParams creates a new ActiveDirectoryPreferredDcDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewActiveDirectoryPreferredDcDeleteParams() *ActiveDirectoryPreferredDcDeleteParams {
	return &ActiveDirectoryPreferredDcDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewActiveDirectoryPreferredDcDeleteParamsWithTimeout creates a new ActiveDirectoryPreferredDcDeleteParams object
// with the ability to set a timeout on a request.
func NewActiveDirectoryPreferredDcDeleteParamsWithTimeout(timeout time.Duration) *ActiveDirectoryPreferredDcDeleteParams {
	return &ActiveDirectoryPreferredDcDeleteParams{
		timeout: timeout,
	}
}

// NewActiveDirectoryPreferredDcDeleteParamsWithContext creates a new ActiveDirectoryPreferredDcDeleteParams object
// with the ability to set a context for a request.
func NewActiveDirectoryPreferredDcDeleteParamsWithContext(ctx context.Context) *ActiveDirectoryPreferredDcDeleteParams {
	return &ActiveDirectoryPreferredDcDeleteParams{
		Context: ctx,
	}
}

// NewActiveDirectoryPreferredDcDeleteParamsWithHTTPClient creates a new ActiveDirectoryPreferredDcDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewActiveDirectoryPreferredDcDeleteParamsWithHTTPClient(client *http.Client) *ActiveDirectoryPreferredDcDeleteParams {
	return &ActiveDirectoryPreferredDcDeleteParams{
		HTTPClient: client,
	}
}

/*
ActiveDirectoryPreferredDcDeleteParams contains all the parameters to send to the API endpoint

	for the active directory preferred dc delete operation.

	Typically these are written to a http.Request.
*/
type ActiveDirectoryPreferredDcDeleteParams struct {

	/* Fqdn.

	   Fully Qualified Domain Name.
	*/
	Fqdn string

	/* ServerIP.

	   DC's IP address.
	*/
	ServerIP string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the active directory preferred dc delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ActiveDirectoryPreferredDcDeleteParams) WithDefaults() *ActiveDirectoryPreferredDcDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the active directory preferred dc delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ActiveDirectoryPreferredDcDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) WithTimeout(timeout time.Duration) *ActiveDirectoryPreferredDcDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) WithContext(ctx context.Context) *ActiveDirectoryPreferredDcDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) WithHTTPClient(client *http.Client) *ActiveDirectoryPreferredDcDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFqdn adds the fqdn to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) WithFqdn(fqdn string) *ActiveDirectoryPreferredDcDeleteParams {
	o.SetFqdn(fqdn)
	return o
}

// SetFqdn adds the fqdn to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) SetFqdn(fqdn string) {
	o.Fqdn = fqdn
}

// WithServerIP adds the serverIP to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) WithServerIP(serverIP string) *ActiveDirectoryPreferredDcDeleteParams {
	o.SetServerIP(serverIP)
	return o
}

// SetServerIP adds the serverIp to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) SetServerIP(serverIP string) {
	o.ServerIP = serverIP
}

// WithSvmUUID adds the svmUUID to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) WithSvmUUID(svmUUID string) *ActiveDirectoryPreferredDcDeleteParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the active directory preferred dc delete params
func (o *ActiveDirectoryPreferredDcDeleteParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *ActiveDirectoryPreferredDcDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param fqdn
	if err := r.SetPathParam("fqdn", o.Fqdn); err != nil {
		return err
	}

	// path param server_ip
	if err := r.SetPathParam("server_ip", o.ServerIP); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
