// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewExportRuleClientsGetParams creates a new ExportRuleClientsGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewExportRuleClientsGetParams() *ExportRuleClientsGetParams {
	return &ExportRuleClientsGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewExportRuleClientsGetParamsWithTimeout creates a new ExportRuleClientsGetParams object
// with the ability to set a timeout on a request.
func NewExportRuleClientsGetParamsWithTimeout(timeout time.Duration) *ExportRuleClientsGetParams {
	return &ExportRuleClientsGetParams{
		timeout: timeout,
	}
}

// NewExportRuleClientsGetParamsWithContext creates a new ExportRuleClientsGetParams object
// with the ability to set a context for a request.
func NewExportRuleClientsGetParamsWithContext(ctx context.Context) *ExportRuleClientsGetParams {
	return &ExportRuleClientsGetParams{
		Context: ctx,
	}
}

// NewExportRuleClientsGetParamsWithHTTPClient creates a new ExportRuleClientsGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewExportRuleClientsGetParamsWithHTTPClient(client *http.Client) *ExportRuleClientsGetParams {
	return &ExportRuleClientsGetParams{
		HTTPClient: client,
	}
}

/*
ExportRuleClientsGetParams contains all the parameters to send to the API endpoint

	for the export rule clients get operation.

	Typically these are written to a http.Request.
*/
type ExportRuleClientsGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* Index.

	   Export Rule Index
	*/
	Index int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* PolicyID.

	   Export Policy ID
	*/
	PolicyID int64

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the export rule clients get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExportRuleClientsGetParams) WithDefaults() *ExportRuleClientsGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the export rule clients get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ExportRuleClientsGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := ExportRuleClientsGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithTimeout(timeout time.Duration) *ExportRuleClientsGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithContext(ctx context.Context) *ExportRuleClientsGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithHTTPClient(client *http.Client) *ExportRuleClientsGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithFields(fields []string) *ExportRuleClientsGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithIndex adds the index to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithIndex(index int64) *ExportRuleClientsGetParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetIndex(index int64) {
	o.Index = index
}

// WithMaxRecords adds the maxRecords to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithMaxRecords(maxRecords *int64) *ExportRuleClientsGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithOrderBy adds the orderBy to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithOrderBy(orderBy []string) *ExportRuleClientsGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithPolicyID adds the policyID to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithPolicyID(policyID int64) *ExportRuleClientsGetParams {
	o.SetPolicyID(policyID)
	return o
}

// SetPolicyID adds the policyId to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetPolicyID(policyID int64) {
	o.PolicyID = policyID
}

// WithReturnRecords adds the returnRecords to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithReturnRecords(returnRecords *bool) *ExportRuleClientsGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the export rule clients get params
func (o *ExportRuleClientsGetParams) WithReturnTimeout(returnTimeout *int64) *ExportRuleClientsGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the export rule clients get params
func (o *ExportRuleClientsGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *ExportRuleClientsGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	// path param policy.id
	if err := r.SetPathParam("policy.id", swag.FormatInt64(o.PolicyID)); err != nil {
		return err
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamExportRuleClientsGet binds the parameter fields
func (o *ExportRuleClientsGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamExportRuleClientsGet binds the parameter order_by
func (o *ExportRuleClientsGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
