// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// FileDirectorySecurityACLDeleteReader is a Reader for the FileDirectorySecurityACLDelete structure.
type FileDirectorySecurityACLDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *FileDirectorySecurityACLDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewFileDirectorySecurityACLDeleteAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewFileDirectorySecurityACLDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewFileDirectorySecurityACLDeleteAccepted creates a FileDirectorySecurityACLDeleteAccepted with default headers values
func NewFileDirectorySecurityACLDeleteAccepted() *FileDirectorySecurityACLDeleteAccepted {
	return &FileDirectorySecurityACLDeleteAccepted{}
}

/*
FileDirectorySecurityACLDeleteAccepted describes a response with status code 202, with default header values.

Accepted
*/
type FileDirectorySecurityACLDeleteAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this file directory security Acl delete accepted response has a 2xx status code
func (o *FileDirectorySecurityACLDeleteAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this file directory security Acl delete accepted response has a 3xx status code
func (o *FileDirectorySecurityACLDeleteAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this file directory security Acl delete accepted response has a 4xx status code
func (o *FileDirectorySecurityACLDeleteAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this file directory security Acl delete accepted response has a 5xx status code
func (o *FileDirectorySecurityACLDeleteAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this file directory security Acl delete accepted response a status code equal to that given
func (o *FileDirectorySecurityACLDeleteAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *FileDirectorySecurityACLDeleteAccepted) Error() string {
	return fmt.Sprintf("[DELETE /protocols/file-security/permissions/{svm.uuid}/{path}/acl/{user}][%d] fileDirectorySecurityAclDeleteAccepted  %+v", 202, o.Payload)
}

func (o *FileDirectorySecurityACLDeleteAccepted) String() string {
	return fmt.Sprintf("[DELETE /protocols/file-security/permissions/{svm.uuid}/{path}/acl/{user}][%d] fileDirectorySecurityAclDeleteAccepted  %+v", 202, o.Payload)
}

func (o *FileDirectorySecurityACLDeleteAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *FileDirectorySecurityACLDeleteAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewFileDirectorySecurityACLDeleteDefault creates a FileDirectorySecurityACLDeleteDefault with default headers values
func NewFileDirectorySecurityACLDeleteDefault(code int) *FileDirectorySecurityACLDeleteDefault {
	return &FileDirectorySecurityACLDeleteDefault{
		_statusCode: code,
	}
}

/*
FileDirectorySecurityACLDeleteDefault describes a response with status code -1, with default header values.

Error
*/
type FileDirectorySecurityACLDeleteDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the file directory security acl delete default response
func (o *FileDirectorySecurityACLDeleteDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this file directory security acl delete default response has a 2xx status code
func (o *FileDirectorySecurityACLDeleteDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this file directory security acl delete default response has a 3xx status code
func (o *FileDirectorySecurityACLDeleteDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this file directory security acl delete default response has a 4xx status code
func (o *FileDirectorySecurityACLDeleteDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this file directory security acl delete default response has a 5xx status code
func (o *FileDirectorySecurityACLDeleteDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this file directory security acl delete default response a status code equal to that given
func (o *FileDirectorySecurityACLDeleteDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *FileDirectorySecurityACLDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /protocols/file-security/permissions/{svm.uuid}/{path}/acl/{user}][%d] file_directory_security_acl_delete default  %+v", o._statusCode, o.Payload)
}

func (o *FileDirectorySecurityACLDeleteDefault) String() string {
	return fmt.Sprintf("[DELETE /protocols/file-security/permissions/{svm.uuid}/{path}/acl/{user}][%d] file_directory_security_acl_delete default  %+v", o._statusCode, o.Payload)
}

func (o *FileDirectorySecurityACLDeleteDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *FileDirectorySecurityACLDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
