// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFpolicyPolicyCollectionGetParams creates a new FpolicyPolicyCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFpolicyPolicyCollectionGetParams() *FpolicyPolicyCollectionGetParams {
	return &FpolicyPolicyCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFpolicyPolicyCollectionGetParamsWithTimeout creates a new FpolicyPolicyCollectionGetParams object
// with the ability to set a timeout on a request.
func NewFpolicyPolicyCollectionGetParamsWithTimeout(timeout time.Duration) *FpolicyPolicyCollectionGetParams {
	return &FpolicyPolicyCollectionGetParams{
		timeout: timeout,
	}
}

// NewFpolicyPolicyCollectionGetParamsWithContext creates a new FpolicyPolicyCollectionGetParams object
// with the ability to set a context for a request.
func NewFpolicyPolicyCollectionGetParamsWithContext(ctx context.Context) *FpolicyPolicyCollectionGetParams {
	return &FpolicyPolicyCollectionGetParams{
		Context: ctx,
	}
}

// NewFpolicyPolicyCollectionGetParamsWithHTTPClient creates a new FpolicyPolicyCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewFpolicyPolicyCollectionGetParamsWithHTTPClient(client *http.Client) *FpolicyPolicyCollectionGetParams {
	return &FpolicyPolicyCollectionGetParams{
		HTTPClient: client,
	}
}

/*
FpolicyPolicyCollectionGetParams contains all the parameters to send to the API endpoint

	for the fpolicy policy collection get operation.

	Typically these are written to a http.Request.
*/
type FpolicyPolicyCollectionGetParams struct {

	/* Enabled.

	   Filter by enabled
	*/
	Enabled *bool

	/* EngineName.

	   Filter by engine.name
	*/
	EngineName *string

	/* EventsName.

	   Filter by events.name
	*/
	EventsName *string

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* Mandatory.

	   Filter by mandatory
	*/
	Mandatory *bool

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Name.

	   Filter by name
	*/
	Name *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* PassthroughRead.

	   Filter by passthrough_read
	*/
	PassthroughRead *bool

	/* Priority.

	   Filter by priority
	*/
	Priority *int64

	/* PrivilegedUser.

	   Filter by privileged_user
	*/
	PrivilegedUser *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* ScopeCheckExtensionsOnDirectories.

	   Filter by scope.check_extensions_on_directories
	*/
	ScopeCheckExtensionsOnDirectories *bool

	/* ScopeExcludeExportPolicies.

	   Filter by scope.exclude_export_policies
	*/
	ScopeExcludeExportPolicies *string

	/* ScopeExcludeExtension.

	   Filter by scope.exclude_extension
	*/
	ScopeExcludeExtension *string

	/* ScopeExcludeShares.

	   Filter by scope.exclude_shares
	*/
	ScopeExcludeShares *string

	/* ScopeExcludeVolumes.

	   Filter by scope.exclude_volumes
	*/
	ScopeExcludeVolumes *string

	/* ScopeIncludeExportPolicies.

	   Filter by scope.include_export_policies
	*/
	ScopeIncludeExportPolicies *string

	/* ScopeIncludeExtension.

	   Filter by scope.include_extension
	*/
	ScopeIncludeExtension *string

	/* ScopeIncludeShares.

	   Filter by scope.include_shares
	*/
	ScopeIncludeShares *string

	/* ScopeIncludeVolumes.

	   Filter by scope.include_volumes
	*/
	ScopeIncludeVolumes *string

	/* ScopeObjectMonitoringWithNoExtension.

	   Filter by scope.object_monitoring_with_no_extension
	*/
	ScopeObjectMonitoringWithNoExtension *bool

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fpolicy policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FpolicyPolicyCollectionGetParams) WithDefaults() *FpolicyPolicyCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fpolicy policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FpolicyPolicyCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := FpolicyPolicyCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithTimeout(timeout time.Duration) *FpolicyPolicyCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithContext(ctx context.Context) *FpolicyPolicyCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithHTTPClient(client *http.Client) *FpolicyPolicyCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEnabled adds the enabled to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithEnabled(enabled *bool) *FpolicyPolicyCollectionGetParams {
	o.SetEnabled(enabled)
	return o
}

// SetEnabled adds the enabled to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetEnabled(enabled *bool) {
	o.Enabled = enabled
}

// WithEngineName adds the engineName to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithEngineName(engineName *string) *FpolicyPolicyCollectionGetParams {
	o.SetEngineName(engineName)
	return o
}

// SetEngineName adds the engineName to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetEngineName(engineName *string) {
	o.EngineName = engineName
}

// WithEventsName adds the eventsName to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithEventsName(eventsName *string) *FpolicyPolicyCollectionGetParams {
	o.SetEventsName(eventsName)
	return o
}

// SetEventsName adds the eventsName to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetEventsName(eventsName *string) {
	o.EventsName = eventsName
}

// WithFields adds the fields to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithFields(fields []string) *FpolicyPolicyCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithMandatory adds the mandatory to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithMandatory(mandatory *bool) *FpolicyPolicyCollectionGetParams {
	o.SetMandatory(mandatory)
	return o
}

// SetMandatory adds the mandatory to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetMandatory(mandatory *bool) {
	o.Mandatory = mandatory
}

// WithMaxRecords adds the maxRecords to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithMaxRecords(maxRecords *int64) *FpolicyPolicyCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithName(name *string) *FpolicyPolicyCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithOrderBy(orderBy []string) *FpolicyPolicyCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithPassthroughRead adds the passthroughRead to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithPassthroughRead(passthroughRead *bool) *FpolicyPolicyCollectionGetParams {
	o.SetPassthroughRead(passthroughRead)
	return o
}

// SetPassthroughRead adds the passthroughRead to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetPassthroughRead(passthroughRead *bool) {
	o.PassthroughRead = passthroughRead
}

// WithPriority adds the priority to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithPriority(priority *int64) *FpolicyPolicyCollectionGetParams {
	o.SetPriority(priority)
	return o
}

// SetPriority adds the priority to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetPriority(priority *int64) {
	o.Priority = priority
}

// WithPrivilegedUser adds the privilegedUser to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithPrivilegedUser(privilegedUser *string) *FpolicyPolicyCollectionGetParams {
	o.SetPrivilegedUser(privilegedUser)
	return o
}

// SetPrivilegedUser adds the privilegedUser to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetPrivilegedUser(privilegedUser *string) {
	o.PrivilegedUser = privilegedUser
}

// WithReturnRecords adds the returnRecords to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithReturnRecords(returnRecords *bool) *FpolicyPolicyCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *FpolicyPolicyCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithScopeCheckExtensionsOnDirectories adds the scopeCheckExtensionsOnDirectories to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeCheckExtensionsOnDirectories(scopeCheckExtensionsOnDirectories *bool) *FpolicyPolicyCollectionGetParams {
	o.SetScopeCheckExtensionsOnDirectories(scopeCheckExtensionsOnDirectories)
	return o
}

// SetScopeCheckExtensionsOnDirectories adds the scopeCheckExtensionsOnDirectories to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeCheckExtensionsOnDirectories(scopeCheckExtensionsOnDirectories *bool) {
	o.ScopeCheckExtensionsOnDirectories = scopeCheckExtensionsOnDirectories
}

// WithScopeExcludeExportPolicies adds the scopeExcludeExportPolicies to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeExcludeExportPolicies(scopeExcludeExportPolicies *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeExcludeExportPolicies(scopeExcludeExportPolicies)
	return o
}

// SetScopeExcludeExportPolicies adds the scopeExcludeExportPolicies to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeExcludeExportPolicies(scopeExcludeExportPolicies *string) {
	o.ScopeExcludeExportPolicies = scopeExcludeExportPolicies
}

// WithScopeExcludeExtension adds the scopeExcludeExtension to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeExcludeExtension(scopeExcludeExtension *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeExcludeExtension(scopeExcludeExtension)
	return o
}

// SetScopeExcludeExtension adds the scopeExcludeExtension to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeExcludeExtension(scopeExcludeExtension *string) {
	o.ScopeExcludeExtension = scopeExcludeExtension
}

// WithScopeExcludeShares adds the scopeExcludeShares to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeExcludeShares(scopeExcludeShares *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeExcludeShares(scopeExcludeShares)
	return o
}

// SetScopeExcludeShares adds the scopeExcludeShares to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeExcludeShares(scopeExcludeShares *string) {
	o.ScopeExcludeShares = scopeExcludeShares
}

// WithScopeExcludeVolumes adds the scopeExcludeVolumes to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeExcludeVolumes(scopeExcludeVolumes *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeExcludeVolumes(scopeExcludeVolumes)
	return o
}

// SetScopeExcludeVolumes adds the scopeExcludeVolumes to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeExcludeVolumes(scopeExcludeVolumes *string) {
	o.ScopeExcludeVolumes = scopeExcludeVolumes
}

// WithScopeIncludeExportPolicies adds the scopeIncludeExportPolicies to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeIncludeExportPolicies(scopeIncludeExportPolicies *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeIncludeExportPolicies(scopeIncludeExportPolicies)
	return o
}

// SetScopeIncludeExportPolicies adds the scopeIncludeExportPolicies to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeIncludeExportPolicies(scopeIncludeExportPolicies *string) {
	o.ScopeIncludeExportPolicies = scopeIncludeExportPolicies
}

// WithScopeIncludeExtension adds the scopeIncludeExtension to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeIncludeExtension(scopeIncludeExtension *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeIncludeExtension(scopeIncludeExtension)
	return o
}

// SetScopeIncludeExtension adds the scopeIncludeExtension to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeIncludeExtension(scopeIncludeExtension *string) {
	o.ScopeIncludeExtension = scopeIncludeExtension
}

// WithScopeIncludeShares adds the scopeIncludeShares to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeIncludeShares(scopeIncludeShares *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeIncludeShares(scopeIncludeShares)
	return o
}

// SetScopeIncludeShares adds the scopeIncludeShares to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeIncludeShares(scopeIncludeShares *string) {
	o.ScopeIncludeShares = scopeIncludeShares
}

// WithScopeIncludeVolumes adds the scopeIncludeVolumes to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeIncludeVolumes(scopeIncludeVolumes *string) *FpolicyPolicyCollectionGetParams {
	o.SetScopeIncludeVolumes(scopeIncludeVolumes)
	return o
}

// SetScopeIncludeVolumes adds the scopeIncludeVolumes to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeIncludeVolumes(scopeIncludeVolumes *string) {
	o.ScopeIncludeVolumes = scopeIncludeVolumes
}

// WithScopeObjectMonitoringWithNoExtension adds the scopeObjectMonitoringWithNoExtension to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithScopeObjectMonitoringWithNoExtension(scopeObjectMonitoringWithNoExtension *bool) *FpolicyPolicyCollectionGetParams {
	o.SetScopeObjectMonitoringWithNoExtension(scopeObjectMonitoringWithNoExtension)
	return o
}

// SetScopeObjectMonitoringWithNoExtension adds the scopeObjectMonitoringWithNoExtension to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetScopeObjectMonitoringWithNoExtension(scopeObjectMonitoringWithNoExtension *bool) {
	o.ScopeObjectMonitoringWithNoExtension = scopeObjectMonitoringWithNoExtension
}

// WithSvmUUID adds the svmUUID to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) WithSvmUUID(svmUUID string) *FpolicyPolicyCollectionGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the fpolicy policy collection get params
func (o *FpolicyPolicyCollectionGetParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FpolicyPolicyCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Enabled != nil {

		// query param enabled
		var qrEnabled bool

		if o.Enabled != nil {
			qrEnabled = *o.Enabled
		}
		qEnabled := swag.FormatBool(qrEnabled)
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.EngineName != nil {

		// query param engine.name
		var qrEngineName string

		if o.EngineName != nil {
			qrEngineName = *o.EngineName
		}
		qEngineName := qrEngineName
		if qEngineName != "" {

			if err := r.SetQueryParam("engine.name", qEngineName); err != nil {
				return err
			}
		}
	}

	if o.EventsName != nil {

		// query param events.name
		var qrEventsName string

		if o.EventsName != nil {
			qrEventsName = *o.EventsName
		}
		qEventsName := qrEventsName
		if qEventsName != "" {

			if err := r.SetQueryParam("events.name", qEventsName); err != nil {
				return err
			}
		}
	}

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.Mandatory != nil {

		// query param mandatory
		var qrMandatory bool

		if o.Mandatory != nil {
			qrMandatory = *o.Mandatory
		}
		qMandatory := swag.FormatBool(qrMandatory)
		if qMandatory != "" {

			if err := r.SetQueryParam("mandatory", qMandatory); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PassthroughRead != nil {

		// query param passthrough_read
		var qrPassthroughRead bool

		if o.PassthroughRead != nil {
			qrPassthroughRead = *o.PassthroughRead
		}
		qPassthroughRead := swag.FormatBool(qrPassthroughRead)
		if qPassthroughRead != "" {

			if err := r.SetQueryParam("passthrough_read", qPassthroughRead); err != nil {
				return err
			}
		}
	}

	if o.Priority != nil {

		// query param priority
		var qrPriority int64

		if o.Priority != nil {
			qrPriority = *o.Priority
		}
		qPriority := swag.FormatInt64(qrPriority)
		if qPriority != "" {

			if err := r.SetQueryParam("priority", qPriority); err != nil {
				return err
			}
		}
	}

	if o.PrivilegedUser != nil {

		// query param privileged_user
		var qrPrivilegedUser string

		if o.PrivilegedUser != nil {
			qrPrivilegedUser = *o.PrivilegedUser
		}
		qPrivilegedUser := qrPrivilegedUser
		if qPrivilegedUser != "" {

			if err := r.SetQueryParam("privileged_user", qPrivilegedUser); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScopeCheckExtensionsOnDirectories != nil {

		// query param scope.check_extensions_on_directories
		var qrScopeCheckExtensionsOnDirectories bool

		if o.ScopeCheckExtensionsOnDirectories != nil {
			qrScopeCheckExtensionsOnDirectories = *o.ScopeCheckExtensionsOnDirectories
		}
		qScopeCheckExtensionsOnDirectories := swag.FormatBool(qrScopeCheckExtensionsOnDirectories)
		if qScopeCheckExtensionsOnDirectories != "" {

			if err := r.SetQueryParam("scope.check_extensions_on_directories", qScopeCheckExtensionsOnDirectories); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludeExportPolicies != nil {

		// query param scope.exclude_export_policies
		var qrScopeExcludeExportPolicies string

		if o.ScopeExcludeExportPolicies != nil {
			qrScopeExcludeExportPolicies = *o.ScopeExcludeExportPolicies
		}
		qScopeExcludeExportPolicies := qrScopeExcludeExportPolicies
		if qScopeExcludeExportPolicies != "" {

			if err := r.SetQueryParam("scope.exclude_export_policies", qScopeExcludeExportPolicies); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludeExtension != nil {

		// query param scope.exclude_extension
		var qrScopeExcludeExtension string

		if o.ScopeExcludeExtension != nil {
			qrScopeExcludeExtension = *o.ScopeExcludeExtension
		}
		qScopeExcludeExtension := qrScopeExcludeExtension
		if qScopeExcludeExtension != "" {

			if err := r.SetQueryParam("scope.exclude_extension", qScopeExcludeExtension); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludeShares != nil {

		// query param scope.exclude_shares
		var qrScopeExcludeShares string

		if o.ScopeExcludeShares != nil {
			qrScopeExcludeShares = *o.ScopeExcludeShares
		}
		qScopeExcludeShares := qrScopeExcludeShares
		if qScopeExcludeShares != "" {

			if err := r.SetQueryParam("scope.exclude_shares", qScopeExcludeShares); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludeVolumes != nil {

		// query param scope.exclude_volumes
		var qrScopeExcludeVolumes string

		if o.ScopeExcludeVolumes != nil {
			qrScopeExcludeVolumes = *o.ScopeExcludeVolumes
		}
		qScopeExcludeVolumes := qrScopeExcludeVolumes
		if qScopeExcludeVolumes != "" {

			if err := r.SetQueryParam("scope.exclude_volumes", qScopeExcludeVolumes); err != nil {
				return err
			}
		}
	}

	if o.ScopeIncludeExportPolicies != nil {

		// query param scope.include_export_policies
		var qrScopeIncludeExportPolicies string

		if o.ScopeIncludeExportPolicies != nil {
			qrScopeIncludeExportPolicies = *o.ScopeIncludeExportPolicies
		}
		qScopeIncludeExportPolicies := qrScopeIncludeExportPolicies
		if qScopeIncludeExportPolicies != "" {

			if err := r.SetQueryParam("scope.include_export_policies", qScopeIncludeExportPolicies); err != nil {
				return err
			}
		}
	}

	if o.ScopeIncludeExtension != nil {

		// query param scope.include_extension
		var qrScopeIncludeExtension string

		if o.ScopeIncludeExtension != nil {
			qrScopeIncludeExtension = *o.ScopeIncludeExtension
		}
		qScopeIncludeExtension := qrScopeIncludeExtension
		if qScopeIncludeExtension != "" {

			if err := r.SetQueryParam("scope.include_extension", qScopeIncludeExtension); err != nil {
				return err
			}
		}
	}

	if o.ScopeIncludeShares != nil {

		// query param scope.include_shares
		var qrScopeIncludeShares string

		if o.ScopeIncludeShares != nil {
			qrScopeIncludeShares = *o.ScopeIncludeShares
		}
		qScopeIncludeShares := qrScopeIncludeShares
		if qScopeIncludeShares != "" {

			if err := r.SetQueryParam("scope.include_shares", qScopeIncludeShares); err != nil {
				return err
			}
		}
	}

	if o.ScopeIncludeVolumes != nil {

		// query param scope.include_volumes
		var qrScopeIncludeVolumes string

		if o.ScopeIncludeVolumes != nil {
			qrScopeIncludeVolumes = *o.ScopeIncludeVolumes
		}
		qScopeIncludeVolumes := qrScopeIncludeVolumes
		if qScopeIncludeVolumes != "" {

			if err := r.SetQueryParam("scope.include_volumes", qScopeIncludeVolumes); err != nil {
				return err
			}
		}
	}

	if o.ScopeObjectMonitoringWithNoExtension != nil {

		// query param scope.object_monitoring_with_no_extension
		var qrScopeObjectMonitoringWithNoExtension bool

		if o.ScopeObjectMonitoringWithNoExtension != nil {
			qrScopeObjectMonitoringWithNoExtension = *o.ScopeObjectMonitoringWithNoExtension
		}
		qScopeObjectMonitoringWithNoExtension := swag.FormatBool(qrScopeObjectMonitoringWithNoExtension)
		if qScopeObjectMonitoringWithNoExtension != "" {

			if err := r.SetQueryParam("scope.object_monitoring_with_no_extension", qScopeObjectMonitoringWithNoExtension); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamFpolicyPolicyCollectionGet binds the parameter fields
func (o *FpolicyPolicyCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamFpolicyPolicyCollectionGet binds the parameter order_by
func (o *FpolicyPolicyCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
