// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewKerberosInterfaceGetParams creates a new KerberosInterfaceGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewKerberosInterfaceGetParams() *KerberosInterfaceGetParams {
	return &KerberosInterfaceGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewKerberosInterfaceGetParamsWithTimeout creates a new KerberosInterfaceGetParams object
// with the ability to set a timeout on a request.
func NewKerberosInterfaceGetParamsWithTimeout(timeout time.Duration) *KerberosInterfaceGetParams {
	return &KerberosInterfaceGetParams{
		timeout: timeout,
	}
}

// NewKerberosInterfaceGetParamsWithContext creates a new KerberosInterfaceGetParams object
// with the ability to set a context for a request.
func NewKerberosInterfaceGetParamsWithContext(ctx context.Context) *KerberosInterfaceGetParams {
	return &KerberosInterfaceGetParams{
		Context: ctx,
	}
}

// NewKerberosInterfaceGetParamsWithHTTPClient creates a new KerberosInterfaceGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewKerberosInterfaceGetParamsWithHTTPClient(client *http.Client) *KerberosInterfaceGetParams {
	return &KerberosInterfaceGetParams{
		HTTPClient: client,
	}
}

/*
KerberosInterfaceGetParams contains all the parameters to send to the API endpoint

	for the kerberos interface get operation.

	Typically these are written to a http.Request.
*/
type KerberosInterfaceGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* InterfaceUUID.

	   Network interface UUID
	*/
	InterfaceUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the kerberos interface get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KerberosInterfaceGetParams) WithDefaults() *KerberosInterfaceGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the kerberos interface get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KerberosInterfaceGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the kerberos interface get params
func (o *KerberosInterfaceGetParams) WithTimeout(timeout time.Duration) *KerberosInterfaceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the kerberos interface get params
func (o *KerberosInterfaceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the kerberos interface get params
func (o *KerberosInterfaceGetParams) WithContext(ctx context.Context) *KerberosInterfaceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the kerberos interface get params
func (o *KerberosInterfaceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the kerberos interface get params
func (o *KerberosInterfaceGetParams) WithHTTPClient(client *http.Client) *KerberosInterfaceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the kerberos interface get params
func (o *KerberosInterfaceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the kerberos interface get params
func (o *KerberosInterfaceGetParams) WithFields(fields []string) *KerberosInterfaceGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the kerberos interface get params
func (o *KerberosInterfaceGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithInterfaceUUID adds the interfaceUUID to the kerberos interface get params
func (o *KerberosInterfaceGetParams) WithInterfaceUUID(interfaceUUID string) *KerberosInterfaceGetParams {
	o.SetInterfaceUUID(interfaceUUID)
	return o
}

// SetInterfaceUUID adds the interfaceUuid to the kerberos interface get params
func (o *KerberosInterfaceGetParams) SetInterfaceUUID(interfaceUUID string) {
	o.InterfaceUUID = interfaceUUID
}

// WriteToRequest writes these params to a swagger request
func (o *KerberosInterfaceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param interface.uuid
	if err := r.SetPathParam("interface.uuid", o.InterfaceUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamKerberosInterfaceGet binds the parameter fields
func (o *KerberosInterfaceGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
