// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVscanOnDemandPolicyCollectionGetParams creates a new VscanOnDemandPolicyCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVscanOnDemandPolicyCollectionGetParams() *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVscanOnDemandPolicyCollectionGetParamsWithTimeout creates a new VscanOnDemandPolicyCollectionGetParams object
// with the ability to set a timeout on a request.
func NewVscanOnDemandPolicyCollectionGetParamsWithTimeout(timeout time.Duration) *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		timeout: timeout,
	}
}

// NewVscanOnDemandPolicyCollectionGetParamsWithContext creates a new VscanOnDemandPolicyCollectionGetParams object
// with the ability to set a context for a request.
func NewVscanOnDemandPolicyCollectionGetParamsWithContext(ctx context.Context) *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		Context: ctx,
	}
}

// NewVscanOnDemandPolicyCollectionGetParamsWithHTTPClient creates a new VscanOnDemandPolicyCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewVscanOnDemandPolicyCollectionGetParamsWithHTTPClient(client *http.Client) *VscanOnDemandPolicyCollectionGetParams {
	return &VscanOnDemandPolicyCollectionGetParams{
		HTTPClient: client,
	}
}

/*
VscanOnDemandPolicyCollectionGetParams contains all the parameters to send to the API endpoint

	for the vscan on demand policy collection get operation.

	Typically these are written to a http.Request.
*/
type VscanOnDemandPolicyCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* LogPath.

	   Filter by log_path
	*/
	LogPath *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Name.

	   Filter by name
	*/
	Name *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* ScanPaths.

	   Filter by scan_paths
	*/
	ScanPaths *string

	/* ScheduleName.

	   Filter by schedule.name
	*/
	ScheduleName *string

	/* ScheduleUUID.

	   Filter by schedule.uuid
	*/
	ScheduleUUID *string

	/* ScopeExcludeExtensions.

	   Filter by scope.exclude_extensions
	*/
	ScopeExcludeExtensions *string

	/* ScopeExcludePaths.

	   Filter by scope.exclude_paths
	*/
	ScopeExcludePaths *string

	/* ScopeIncludeExtensions.

	   Filter by scope.include_extensions
	*/
	ScopeIncludeExtensions *string

	/* ScopeMaxFileSize.

	   Filter by scope.max_file_size
	*/
	ScopeMaxFileSize *int64

	/* ScopeScanWithoutExtension.

	   Filter by scope.scan_without_extension
	*/
	ScopeScanWithoutExtension *bool

	/* SvmName.

	   Filter by svm.name
	*/
	SvmName *string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the vscan on demand policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanOnDemandPolicyCollectionGetParams) WithDefaults() *VscanOnDemandPolicyCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the vscan on demand policy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanOnDemandPolicyCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := VscanOnDemandPolicyCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithTimeout(timeout time.Duration) *VscanOnDemandPolicyCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithContext(ctx context.Context) *VscanOnDemandPolicyCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithHTTPClient(client *http.Client) *VscanOnDemandPolicyCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithFields(fields []string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithLogPath adds the logPath to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithLogPath(logPath *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetLogPath(logPath)
	return o
}

// SetLogPath adds the logPath to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetLogPath(logPath *string) {
	o.LogPath = logPath
}

// WithMaxRecords adds the maxRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithMaxRecords(maxRecords *int64) *VscanOnDemandPolicyCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithName(name *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithOrderBy(orderBy []string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithReturnRecords(returnRecords *bool) *VscanOnDemandPolicyCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *VscanOnDemandPolicyCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithScanPaths adds the scanPaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScanPaths(scanPaths *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScanPaths(scanPaths)
	return o
}

// SetScanPaths adds the scanPaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScanPaths(scanPaths *string) {
	o.ScanPaths = scanPaths
}

// WithScheduleName adds the scheduleName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScheduleName(scheduleName *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScheduleName(scheduleName)
	return o
}

// SetScheduleName adds the scheduleName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScheduleName(scheduleName *string) {
	o.ScheduleName = scheduleName
}

// WithScheduleUUID adds the scheduleUUID to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScheduleUUID(scheduleUUID *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScheduleUUID(scheduleUUID)
	return o
}

// SetScheduleUUID adds the scheduleUuid to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScheduleUUID(scheduleUUID *string) {
	o.ScheduleUUID = scheduleUUID
}

// WithScopeExcludeExtensions adds the scopeExcludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeExcludeExtensions(scopeExcludeExtensions *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeExcludeExtensions(scopeExcludeExtensions)
	return o
}

// SetScopeExcludeExtensions adds the scopeExcludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeExcludeExtensions(scopeExcludeExtensions *string) {
	o.ScopeExcludeExtensions = scopeExcludeExtensions
}

// WithScopeExcludePaths adds the scopeExcludePaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeExcludePaths(scopeExcludePaths *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeExcludePaths(scopeExcludePaths)
	return o
}

// SetScopeExcludePaths adds the scopeExcludePaths to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeExcludePaths(scopeExcludePaths *string) {
	o.ScopeExcludePaths = scopeExcludePaths
}

// WithScopeIncludeExtensions adds the scopeIncludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeIncludeExtensions(scopeIncludeExtensions *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeIncludeExtensions(scopeIncludeExtensions)
	return o
}

// SetScopeIncludeExtensions adds the scopeIncludeExtensions to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeIncludeExtensions(scopeIncludeExtensions *string) {
	o.ScopeIncludeExtensions = scopeIncludeExtensions
}

// WithScopeMaxFileSize adds the scopeMaxFileSize to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeMaxFileSize(scopeMaxFileSize *int64) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeMaxFileSize(scopeMaxFileSize)
	return o
}

// SetScopeMaxFileSize adds the scopeMaxFileSize to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeMaxFileSize(scopeMaxFileSize *int64) {
	o.ScopeMaxFileSize = scopeMaxFileSize
}

// WithScopeScanWithoutExtension adds the scopeScanWithoutExtension to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithScopeScanWithoutExtension(scopeScanWithoutExtension *bool) *VscanOnDemandPolicyCollectionGetParams {
	o.SetScopeScanWithoutExtension(scopeScanWithoutExtension)
	return o
}

// SetScopeScanWithoutExtension adds the scopeScanWithoutExtension to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetScopeScanWithoutExtension(scopeScanWithoutExtension *bool) {
	o.ScopeScanWithoutExtension = scopeScanWithoutExtension
}

// WithSvmName adds the svmName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithSvmName(svmName *string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetSvmName(svmName)
	return o
}

// SetSvmName adds the svmName to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetSvmName(svmName *string) {
	o.SvmName = svmName
}

// WithSvmUUID adds the svmUUID to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) WithSvmUUID(svmUUID string) *VscanOnDemandPolicyCollectionGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the vscan on demand policy collection get params
func (o *VscanOnDemandPolicyCollectionGetParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *VscanOnDemandPolicyCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.LogPath != nil {

		// query param log_path
		var qrLogPath string

		if o.LogPath != nil {
			qrLogPath = *o.LogPath
		}
		qLogPath := qrLogPath
		if qLogPath != "" {

			if err := r.SetQueryParam("log_path", qLogPath); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScanPaths != nil {

		// query param scan_paths
		var qrScanPaths string

		if o.ScanPaths != nil {
			qrScanPaths = *o.ScanPaths
		}
		qScanPaths := qrScanPaths
		if qScanPaths != "" {

			if err := r.SetQueryParam("scan_paths", qScanPaths); err != nil {
				return err
			}
		}
	}

	if o.ScheduleName != nil {

		// query param schedule.name
		var qrScheduleName string

		if o.ScheduleName != nil {
			qrScheduleName = *o.ScheduleName
		}
		qScheduleName := qrScheduleName
		if qScheduleName != "" {

			if err := r.SetQueryParam("schedule.name", qScheduleName); err != nil {
				return err
			}
		}
	}

	if o.ScheduleUUID != nil {

		// query param schedule.uuid
		var qrScheduleUUID string

		if o.ScheduleUUID != nil {
			qrScheduleUUID = *o.ScheduleUUID
		}
		qScheduleUUID := qrScheduleUUID
		if qScheduleUUID != "" {

			if err := r.SetQueryParam("schedule.uuid", qScheduleUUID); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludeExtensions != nil {

		// query param scope.exclude_extensions
		var qrScopeExcludeExtensions string

		if o.ScopeExcludeExtensions != nil {
			qrScopeExcludeExtensions = *o.ScopeExcludeExtensions
		}
		qScopeExcludeExtensions := qrScopeExcludeExtensions
		if qScopeExcludeExtensions != "" {

			if err := r.SetQueryParam("scope.exclude_extensions", qScopeExcludeExtensions); err != nil {
				return err
			}
		}
	}

	if o.ScopeExcludePaths != nil {

		// query param scope.exclude_paths
		var qrScopeExcludePaths string

		if o.ScopeExcludePaths != nil {
			qrScopeExcludePaths = *o.ScopeExcludePaths
		}
		qScopeExcludePaths := qrScopeExcludePaths
		if qScopeExcludePaths != "" {

			if err := r.SetQueryParam("scope.exclude_paths", qScopeExcludePaths); err != nil {
				return err
			}
		}
	}

	if o.ScopeIncludeExtensions != nil {

		// query param scope.include_extensions
		var qrScopeIncludeExtensions string

		if o.ScopeIncludeExtensions != nil {
			qrScopeIncludeExtensions = *o.ScopeIncludeExtensions
		}
		qScopeIncludeExtensions := qrScopeIncludeExtensions
		if qScopeIncludeExtensions != "" {

			if err := r.SetQueryParam("scope.include_extensions", qScopeIncludeExtensions); err != nil {
				return err
			}
		}
	}

	if o.ScopeMaxFileSize != nil {

		// query param scope.max_file_size
		var qrScopeMaxFileSize int64

		if o.ScopeMaxFileSize != nil {
			qrScopeMaxFileSize = *o.ScopeMaxFileSize
		}
		qScopeMaxFileSize := swag.FormatInt64(qrScopeMaxFileSize)
		if qScopeMaxFileSize != "" {

			if err := r.SetQueryParam("scope.max_file_size", qScopeMaxFileSize); err != nil {
				return err
			}
		}
	}

	if o.ScopeScanWithoutExtension != nil {

		// query param scope.scan_without_extension
		var qrScopeScanWithoutExtension bool

		if o.ScopeScanWithoutExtension != nil {
			qrScopeScanWithoutExtension = *o.ScopeScanWithoutExtension
		}
		qScopeScanWithoutExtension := swag.FormatBool(qrScopeScanWithoutExtension)
		if qScopeScanWithoutExtension != "" {

			if err := r.SetQueryParam("scope.scan_without_extension", qScopeScanWithoutExtension); err != nil {
				return err
			}
		}
	}

	if o.SvmName != nil {

		// query param svm.name
		var qrSvmName string

		if o.SvmName != nil {
			qrSvmName = *o.SvmName
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamVscanOnDemandPolicyCollectionGet binds the parameter fields
func (o *VscanOnDemandPolicyCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamVscanOnDemandPolicyCollectionGet binds the parameter order_by
func (o *VscanOnDemandPolicyCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
