// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// LdapSchemaGetReader is a Reader for the LdapSchemaGet structure.
type LdapSchemaGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *LdapSchemaGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewLdapSchemaGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewLdapSchemaGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewLdapSchemaGetOK creates a LdapSchemaGetOK with default headers values
func NewLdapSchemaGetOK() *LdapSchemaGetOK {
	return &LdapSchemaGetOK{}
}

/*
LdapSchemaGetOK describes a response with status code 200, with default header values.

OK
*/
type LdapSchemaGetOK struct {
	Payload *models.LdapSchema
}

// IsSuccess returns true when this ldap schema get o k response has a 2xx status code
func (o *LdapSchemaGetOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this ldap schema get o k response has a 3xx status code
func (o *LdapSchemaGetOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this ldap schema get o k response has a 4xx status code
func (o *LdapSchemaGetOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this ldap schema get o k response has a 5xx status code
func (o *LdapSchemaGetOK) IsServerError() bool {
	return false
}

// IsCode returns true when this ldap schema get o k response a status code equal to that given
func (o *LdapSchemaGetOK) IsCode(code int) bool {
	return code == 200
}

func (o *LdapSchemaGetOK) Error() string {
	return fmt.Sprintf("[GET /name-services/ldap-schemas/{owner.uuid}/{name}][%d] ldapSchemaGetOK  %+v", 200, o.Payload)
}

func (o *LdapSchemaGetOK) String() string {
	return fmt.Sprintf("[GET /name-services/ldap-schemas/{owner.uuid}/{name}][%d] ldapSchemaGetOK  %+v", 200, o.Payload)
}

func (o *LdapSchemaGetOK) GetPayload() *models.LdapSchema {
	return o.Payload
}

func (o *LdapSchemaGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.LdapSchema)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewLdapSchemaGetDefault creates a LdapSchemaGetDefault with default headers values
func NewLdapSchemaGetDefault(code int) *LdapSchemaGetDefault {
	return &LdapSchemaGetDefault{
		_statusCode: code,
	}
}

/*
LdapSchemaGetDefault describes a response with status code -1, with default header values.

Error
*/
type LdapSchemaGetDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the ldap schema get default response
func (o *LdapSchemaGetDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this ldap schema get default response has a 2xx status code
func (o *LdapSchemaGetDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this ldap schema get default response has a 3xx status code
func (o *LdapSchemaGetDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this ldap schema get default response has a 4xx status code
func (o *LdapSchemaGetDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this ldap schema get default response has a 5xx status code
func (o *LdapSchemaGetDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this ldap schema get default response a status code equal to that given
func (o *LdapSchemaGetDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *LdapSchemaGetDefault) Error() string {
	return fmt.Sprintf("[GET /name-services/ldap-schemas/{owner.uuid}/{name}][%d] ldap_schema_get default  %+v", o._statusCode, o.Payload)
}

func (o *LdapSchemaGetDefault) String() string {
	return fmt.Sprintf("[GET /name-services/ldap-schemas/{owner.uuid}/{name}][%d] ldap_schema_get default  %+v", o._statusCode, o.Payload)
}

func (o *LdapSchemaGetDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *LdapSchemaGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
