// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3ServiceCreateReader is a Reader for the S3ServiceCreate structure.
type S3ServiceCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3ServiceCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewS3ServiceCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3ServiceCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3ServiceCreateCreated creates a S3ServiceCreateCreated with default headers values
func NewS3ServiceCreateCreated() *S3ServiceCreateCreated {
	return &S3ServiceCreateCreated{}
}

/*
S3ServiceCreateCreated describes a response with status code 201, with default header values.

Created
*/
type S3ServiceCreateCreated struct {

	/* Useful for tracking the resource location
	 */
	Location string

	Payload *models.S3ServicePostResponse
}

// IsSuccess returns true when this s3 service create created response has a 2xx status code
func (o *S3ServiceCreateCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this s3 service create created response has a 3xx status code
func (o *S3ServiceCreateCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this s3 service create created response has a 4xx status code
func (o *S3ServiceCreateCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this s3 service create created response has a 5xx status code
func (o *S3ServiceCreateCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this s3 service create created response a status code equal to that given
func (o *S3ServiceCreateCreated) IsCode(code int) bool {
	return code == 201
}

func (o *S3ServiceCreateCreated) Error() string {
	return fmt.Sprintf("[POST /protocols/s3/services][%d] s3ServiceCreateCreated  %+v", 201, o.Payload)
}

func (o *S3ServiceCreateCreated) String() string {
	return fmt.Sprintf("[POST /protocols/s3/services][%d] s3ServiceCreateCreated  %+v", 201, o.Payload)
}

func (o *S3ServiceCreateCreated) GetPayload() *models.S3ServicePostResponse {
	return o.Payload
}

func (o *S3ServiceCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	o.Payload = new(models.S3ServicePostResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewS3ServiceCreateDefault creates a S3ServiceCreateDefault with default headers values
func NewS3ServiceCreateDefault(code int) *S3ServiceCreateDefault {
	return &S3ServiceCreateDefault{
		_statusCode: code,
	}
}

/*
	S3ServiceCreateDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 2621706    | The specified SVM UUID is incorrect for the specified SVM name. |
| 92405789   | The specified object server name contains invalid characters or not a fully qualified domain name. Valid characters for an object store server name are 0-9, A-Z, a-z, \".\", and \"-\". |
| 92405790   | Object store server names must have between 1 and 15 characters. |
| 92405839   | Creating an object store server requires an effective cluster version of data ONTAP 9.7.0 or later. Upgrade all the nodes to 9.7.0 or later and try the operation again. |
| 92405853   | Failed to create the object store server because Cloud Volumes ONTAP does not support object store servers. |
| 92405863   | An error occurs when creating an S3 user or bucket. The reason for failure is detailed in the error message. Follow the error codes specified for the user or bucket endpoints to see details for the failure. |
| 92405884   | An object store server can only be created on a data SVM. An object store server can also be created on a system SVM on a mixed platform cluster. |
*/
type S3ServiceCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 service create default response
func (o *S3ServiceCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this s3 service create default response has a 2xx status code
func (o *S3ServiceCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this s3 service create default response has a 3xx status code
func (o *S3ServiceCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this s3 service create default response has a 4xx status code
func (o *S3ServiceCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this s3 service create default response has a 5xx status code
func (o *S3ServiceCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this s3 service create default response a status code equal to that given
func (o *S3ServiceCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *S3ServiceCreateDefault) Error() string {
	return fmt.Sprintf("[POST /protocols/s3/services][%d] s3_service_create default  %+v", o._statusCode, o.Payload)
}

func (o *S3ServiceCreateDefault) String() string {
	return fmt.Sprintf("[POST /protocols/s3/services][%d] s3_service_create default  %+v", o._statusCode, o.Payload)
}

func (o *S3ServiceCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3ServiceCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
