// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIscsiServiceGetParams creates a new IscsiServiceGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIscsiServiceGetParams() *IscsiServiceGetParams {
	return &IscsiServiceGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIscsiServiceGetParamsWithTimeout creates a new IscsiServiceGetParams object
// with the ability to set a timeout on a request.
func NewIscsiServiceGetParamsWithTimeout(timeout time.Duration) *IscsiServiceGetParams {
	return &IscsiServiceGetParams{
		timeout: timeout,
	}
}

// NewIscsiServiceGetParamsWithContext creates a new IscsiServiceGetParams object
// with the ability to set a context for a request.
func NewIscsiServiceGetParamsWithContext(ctx context.Context) *IscsiServiceGetParams {
	return &IscsiServiceGetParams{
		Context: ctx,
	}
}

// NewIscsiServiceGetParamsWithHTTPClient creates a new IscsiServiceGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewIscsiServiceGetParamsWithHTTPClient(client *http.Client) *IscsiServiceGetParams {
	return &IscsiServiceGetParams{
		HTTPClient: client,
	}
}

/*
IscsiServiceGetParams contains all the parameters to send to the API endpoint

	for the iscsi service get operation.

	Typically these are written to a http.Request.
*/
type IscsiServiceGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* SvmUUID.

	   The unique identifier of the SVM for which to retrieve the iSCSI service.

	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the iscsi service get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IscsiServiceGetParams) WithDefaults() *IscsiServiceGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the iscsi service get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IscsiServiceGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the iscsi service get params
func (o *IscsiServiceGetParams) WithTimeout(timeout time.Duration) *IscsiServiceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the iscsi service get params
func (o *IscsiServiceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the iscsi service get params
func (o *IscsiServiceGetParams) WithContext(ctx context.Context) *IscsiServiceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the iscsi service get params
func (o *IscsiServiceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the iscsi service get params
func (o *IscsiServiceGetParams) WithHTTPClient(client *http.Client) *IscsiServiceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the iscsi service get params
func (o *IscsiServiceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the iscsi service get params
func (o *IscsiServiceGetParams) WithFields(fields []string) *IscsiServiceGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the iscsi service get params
func (o *IscsiServiceGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithSvmUUID adds the svmUUID to the iscsi service get params
func (o *IscsiServiceGetParams) WithSvmUUID(svmUUID string) *IscsiServiceGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the iscsi service get params
func (o *IscsiServiceGetParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *IscsiServiceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamIscsiServiceGet binds the parameter fields
func (o *IscsiServiceGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
