// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewPortsetGetParams creates a new PortsetGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPortsetGetParams() *PortsetGetParams {
	return &PortsetGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPortsetGetParamsWithTimeout creates a new PortsetGetParams object
// with the ability to set a timeout on a request.
func NewPortsetGetParamsWithTimeout(timeout time.Duration) *PortsetGetParams {
	return &PortsetGetParams{
		timeout: timeout,
	}
}

// NewPortsetGetParamsWithContext creates a new PortsetGetParams object
// with the ability to set a context for a request.
func NewPortsetGetParamsWithContext(ctx context.Context) *PortsetGetParams {
	return &PortsetGetParams{
		Context: ctx,
	}
}

// NewPortsetGetParamsWithHTTPClient creates a new PortsetGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewPortsetGetParamsWithHTTPClient(client *http.Client) *PortsetGetParams {
	return &PortsetGetParams{
		HTTPClient: client,
	}
}

/*
PortsetGetParams contains all the parameters to send to the API endpoint

	for the portset get operation.

	Typically these are written to a http.Request.
*/
type PortsetGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* UUID.

	   The unique identifier of the portset.

	*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the portset get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PortsetGetParams) WithDefaults() *PortsetGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the portset get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PortsetGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the portset get params
func (o *PortsetGetParams) WithTimeout(timeout time.Duration) *PortsetGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the portset get params
func (o *PortsetGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the portset get params
func (o *PortsetGetParams) WithContext(ctx context.Context) *PortsetGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the portset get params
func (o *PortsetGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the portset get params
func (o *PortsetGetParams) WithHTTPClient(client *http.Client) *PortsetGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the portset get params
func (o *PortsetGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the portset get params
func (o *PortsetGetParams) WithFields(fields []string) *PortsetGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the portset get params
func (o *PortsetGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithUUID adds the uuid to the portset get params
func (o *PortsetGetParams) WithUUID(uuid string) *PortsetGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the portset get params
func (o *PortsetGetParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *PortsetGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamPortsetGet binds the parameter fields
func (o *PortsetGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
