// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewPortsetInterfaceGetParams creates a new PortsetInterfaceGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPortsetInterfaceGetParams() *PortsetInterfaceGetParams {
	return &PortsetInterfaceGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPortsetInterfaceGetParamsWithTimeout creates a new PortsetInterfaceGetParams object
// with the ability to set a timeout on a request.
func NewPortsetInterfaceGetParamsWithTimeout(timeout time.Duration) *PortsetInterfaceGetParams {
	return &PortsetInterfaceGetParams{
		timeout: timeout,
	}
}

// NewPortsetInterfaceGetParamsWithContext creates a new PortsetInterfaceGetParams object
// with the ability to set a context for a request.
func NewPortsetInterfaceGetParamsWithContext(ctx context.Context) *PortsetInterfaceGetParams {
	return &PortsetInterfaceGetParams{
		Context: ctx,
	}
}

// NewPortsetInterfaceGetParamsWithHTTPClient creates a new PortsetInterfaceGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewPortsetInterfaceGetParamsWithHTTPClient(client *http.Client) *PortsetInterfaceGetParams {
	return &PortsetInterfaceGetParams{
		HTTPClient: client,
	}
}

/*
PortsetInterfaceGetParams contains all the parameters to send to the API endpoint

	for the portset interface get operation.

	Typically these are written to a http.Request.
*/
type PortsetInterfaceGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* PortsetUUID.

	   The unique identifier of the portset.

	*/
	PortsetUUID string

	/* UUID.

	   The unique identifier of the network interface in the portset.

	*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the portset interface get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PortsetInterfaceGetParams) WithDefaults() *PortsetInterfaceGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the portset interface get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PortsetInterfaceGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the portset interface get params
func (o *PortsetInterfaceGetParams) WithTimeout(timeout time.Duration) *PortsetInterfaceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the portset interface get params
func (o *PortsetInterfaceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the portset interface get params
func (o *PortsetInterfaceGetParams) WithContext(ctx context.Context) *PortsetInterfaceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the portset interface get params
func (o *PortsetInterfaceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the portset interface get params
func (o *PortsetInterfaceGetParams) WithHTTPClient(client *http.Client) *PortsetInterfaceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the portset interface get params
func (o *PortsetInterfaceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the portset interface get params
func (o *PortsetInterfaceGetParams) WithFields(fields []string) *PortsetInterfaceGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the portset interface get params
func (o *PortsetInterfaceGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithPortsetUUID adds the portsetUUID to the portset interface get params
func (o *PortsetInterfaceGetParams) WithPortsetUUID(portsetUUID string) *PortsetInterfaceGetParams {
	o.SetPortsetUUID(portsetUUID)
	return o
}

// SetPortsetUUID adds the portsetUuid to the portset interface get params
func (o *PortsetInterfaceGetParams) SetPortsetUUID(portsetUUID string) {
	o.PortsetUUID = portsetUUID
}

// WithUUID adds the uuid to the portset interface get params
func (o *PortsetInterfaceGetParams) WithUUID(uuid string) *PortsetInterfaceGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the portset interface get params
func (o *PortsetInterfaceGetParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *PortsetInterfaceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param portset.uuid
	if err := r.SetPathParam("portset.uuid", o.PortsetUUID); err != nil {
		return err
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamPortsetInterfaceGet binds the parameter fields
func (o *PortsetInterfaceGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
