// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewAwsKmsCreateParams creates a new AwsKmsCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAwsKmsCreateParams() *AwsKmsCreateParams {
	return &AwsKmsCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAwsKmsCreateParamsWithTimeout creates a new AwsKmsCreateParams object
// with the ability to set a timeout on a request.
func NewAwsKmsCreateParamsWithTimeout(timeout time.Duration) *AwsKmsCreateParams {
	return &AwsKmsCreateParams{
		timeout: timeout,
	}
}

// NewAwsKmsCreateParamsWithContext creates a new AwsKmsCreateParams object
// with the ability to set a context for a request.
func NewAwsKmsCreateParamsWithContext(ctx context.Context) *AwsKmsCreateParams {
	return &AwsKmsCreateParams{
		Context: ctx,
	}
}

// NewAwsKmsCreateParamsWithHTTPClient creates a new AwsKmsCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewAwsKmsCreateParamsWithHTTPClient(client *http.Client) *AwsKmsCreateParams {
	return &AwsKmsCreateParams{
		HTTPClient: client,
	}
}

/*
AwsKmsCreateParams contains all the parameters to send to the API endpoint

	for the aws kms create operation.

	Typically these are written to a http.Request.
*/
type AwsKmsCreateParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.AwsKms

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecords *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the aws kms create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AwsKmsCreateParams) WithDefaults() *AwsKmsCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the aws kms create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AwsKmsCreateParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(false)
	)

	val := AwsKmsCreateParams{
		ReturnRecords: &returnRecordsDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the aws kms create params
func (o *AwsKmsCreateParams) WithTimeout(timeout time.Duration) *AwsKmsCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aws kms create params
func (o *AwsKmsCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aws kms create params
func (o *AwsKmsCreateParams) WithContext(ctx context.Context) *AwsKmsCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aws kms create params
func (o *AwsKmsCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aws kms create params
func (o *AwsKmsCreateParams) WithHTTPClient(client *http.Client) *AwsKmsCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aws kms create params
func (o *AwsKmsCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the aws kms create params
func (o *AwsKmsCreateParams) WithInfo(info *models.AwsKms) *AwsKmsCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the aws kms create params
func (o *AwsKmsCreateParams) SetInfo(info *models.AwsKms) {
	o.Info = info
}

// WithReturnRecords adds the returnRecords to the aws kms create params
func (o *AwsKmsCreateParams) WithReturnRecords(returnRecords *bool) *AwsKmsCreateParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the aws kms create params
func (o *AwsKmsCreateParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *AwsKmsCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
