// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// AwsKmsGetReader is a Reader for the AwsKmsGet structure.
type AwsKmsGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *AwsKmsGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewAwsKmsGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewAwsKmsGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewAwsKmsGetOK creates a AwsKmsGetOK with default headers values
func NewAwsKmsGetOK() *AwsKmsGetOK {
	return &AwsKmsGetOK{}
}

/*
AwsKmsGetOK describes a response with status code 200, with default header values.

OK
*/
type AwsKmsGetOK struct {
	Payload *models.AwsKms
}

// IsSuccess returns true when this aws kms get o k response has a 2xx status code
func (o *AwsKmsGetOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this aws kms get o k response has a 3xx status code
func (o *AwsKmsGetOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this aws kms get o k response has a 4xx status code
func (o *AwsKmsGetOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this aws kms get o k response has a 5xx status code
func (o *AwsKmsGetOK) IsServerError() bool {
	return false
}

// IsCode returns true when this aws kms get o k response a status code equal to that given
func (o *AwsKmsGetOK) IsCode(code int) bool {
	return code == 200
}

func (o *AwsKmsGetOK) Error() string {
	return fmt.Sprintf("[GET /security/aws-kms/{uuid}][%d] awsKmsGetOK  %+v", 200, o.Payload)
}

func (o *AwsKmsGetOK) String() string {
	return fmt.Sprintf("[GET /security/aws-kms/{uuid}][%d] awsKmsGetOK  %+v", 200, o.Payload)
}

func (o *AwsKmsGetOK) GetPayload() *models.AwsKms {
	return o.Payload
}

func (o *AwsKmsGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AwsKms)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewAwsKmsGetDefault creates a AwsKmsGetDefault with default headers values
func NewAwsKmsGetDefault(code int) *AwsKmsGetDefault {
	return &AwsKmsGetDefault{
		_statusCode: code,
	}
}

/*
	AwsKmsGetDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 65537551 | Top-level internal key protection key (KEK) unavailable on one or more nodes. |
| 65537552 | Embedded KMIP server status not available. |
| 65537915 | The Amazon Web Service Key Management Service is unreachable from one or more nodes. |
*/
type AwsKmsGetDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the aws kms get default response
func (o *AwsKmsGetDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this aws kms get default response has a 2xx status code
func (o *AwsKmsGetDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this aws kms get default response has a 3xx status code
func (o *AwsKmsGetDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this aws kms get default response has a 4xx status code
func (o *AwsKmsGetDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this aws kms get default response has a 5xx status code
func (o *AwsKmsGetDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this aws kms get default response a status code equal to that given
func (o *AwsKmsGetDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *AwsKmsGetDefault) Error() string {
	return fmt.Sprintf("[GET /security/aws-kms/{uuid}][%d] aws_kms_get default  %+v", o._statusCode, o.Payload)
}

func (o *AwsKmsGetDefault) String() string {
	return fmt.Sprintf("[GET /security/aws-kms/{uuid}][%d] aws_kms_get default  %+v", o._statusCode, o.Payload)
}

func (o *AwsKmsGetDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *AwsKmsGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
