// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewIpsecModifyParams creates a new IpsecModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpsecModifyParams() *IpsecModifyParams {
	return &IpsecModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpsecModifyParamsWithTimeout creates a new IpsecModifyParams object
// with the ability to set a timeout on a request.
func NewIpsecModifyParamsWithTimeout(timeout time.Duration) *IpsecModifyParams {
	return &IpsecModifyParams{
		timeout: timeout,
	}
}

// NewIpsecModifyParamsWithContext creates a new IpsecModifyParams object
// with the ability to set a context for a request.
func NewIpsecModifyParamsWithContext(ctx context.Context) *IpsecModifyParams {
	return &IpsecModifyParams{
		Context: ctx,
	}
}

// NewIpsecModifyParamsWithHTTPClient creates a new IpsecModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpsecModifyParamsWithHTTPClient(client *http.Client) *IpsecModifyParams {
	return &IpsecModifyParams{
		HTTPClient: client,
	}
}

/*
IpsecModifyParams contains all the parameters to send to the API endpoint

	for the ipsec modify operation.

	Typically these are written to a http.Request.
*/
type IpsecModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.Ipsec

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipsec modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecModifyParams) WithDefaults() *IpsecModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipsec modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipsec modify params
func (o *IpsecModifyParams) WithTimeout(timeout time.Duration) *IpsecModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipsec modify params
func (o *IpsecModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipsec modify params
func (o *IpsecModifyParams) WithContext(ctx context.Context) *IpsecModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipsec modify params
func (o *IpsecModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipsec modify params
func (o *IpsecModifyParams) WithHTTPClient(client *http.Client) *IpsecModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipsec modify params
func (o *IpsecModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the ipsec modify params
func (o *IpsecModifyParams) WithInfo(info *models.Ipsec) *IpsecModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the ipsec modify params
func (o *IpsecModifyParams) SetInfo(info *models.Ipsec) {
	o.Info = info
}

// WriteToRequest writes these params to a swagger request
func (o *IpsecModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
