// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewMultiAdminVerifyRuleModifyParams creates a new MultiAdminVerifyRuleModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMultiAdminVerifyRuleModifyParams() *MultiAdminVerifyRuleModifyParams {
	return &MultiAdminVerifyRuleModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMultiAdminVerifyRuleModifyParamsWithTimeout creates a new MultiAdminVerifyRuleModifyParams object
// with the ability to set a timeout on a request.
func NewMultiAdminVerifyRuleModifyParamsWithTimeout(timeout time.Duration) *MultiAdminVerifyRuleModifyParams {
	return &MultiAdminVerifyRuleModifyParams{
		timeout: timeout,
	}
}

// NewMultiAdminVerifyRuleModifyParamsWithContext creates a new MultiAdminVerifyRuleModifyParams object
// with the ability to set a context for a request.
func NewMultiAdminVerifyRuleModifyParamsWithContext(ctx context.Context) *MultiAdminVerifyRuleModifyParams {
	return &MultiAdminVerifyRuleModifyParams{
		Context: ctx,
	}
}

// NewMultiAdminVerifyRuleModifyParamsWithHTTPClient creates a new MultiAdminVerifyRuleModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewMultiAdminVerifyRuleModifyParamsWithHTTPClient(client *http.Client) *MultiAdminVerifyRuleModifyParams {
	return &MultiAdminVerifyRuleModifyParams{
		HTTPClient: client,
	}
}

/*
MultiAdminVerifyRuleModifyParams contains all the parameters to send to the API endpoint

	for the multi admin verify rule modify operation.

	Typically these are written to a http.Request.
*/
type MultiAdminVerifyRuleModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.MultiAdminVerifyRule

	// Operation.
	Operation string

	// OwnerUUID.
	OwnerUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the multi admin verify rule modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MultiAdminVerifyRuleModifyParams) WithDefaults() *MultiAdminVerifyRuleModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the multi admin verify rule modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MultiAdminVerifyRuleModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) WithTimeout(timeout time.Duration) *MultiAdminVerifyRuleModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) WithContext(ctx context.Context) *MultiAdminVerifyRuleModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) WithHTTPClient(client *http.Client) *MultiAdminVerifyRuleModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) WithInfo(info *models.MultiAdminVerifyRule) *MultiAdminVerifyRuleModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) SetInfo(info *models.MultiAdminVerifyRule) {
	o.Info = info
}

// WithOperation adds the operation to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) WithOperation(operation string) *MultiAdminVerifyRuleModifyParams {
	o.SetOperation(operation)
	return o
}

// SetOperation adds the operation to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) SetOperation(operation string) {
	o.Operation = operation
}

// WithOwnerUUID adds the ownerUUID to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) WithOwnerUUID(ownerUUID string) *MultiAdminVerifyRuleModifyParams {
	o.SetOwnerUUID(ownerUUID)
	return o
}

// SetOwnerUUID adds the ownerUuid to the multi admin verify rule modify params
func (o *MultiAdminVerifyRuleModifyParams) SetOwnerUUID(ownerUUID string) {
	o.OwnerUUID = ownerUUID
}

// WriteToRequest writes these params to a swagger request
func (o *MultiAdminVerifyRuleModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param operation
	if err := r.SetPathParam("operation", o.Operation); err != nil {
		return err
	}

	// path param owner.uuid
	if err := r.SetPathParam("owner.uuid", o.OwnerUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
