// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// CloudStoreCreateReader is a Reader for the CloudStoreCreate structure.
type CloudStoreCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CloudStoreCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewCloudStoreCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewCloudStoreCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCloudStoreCreateAccepted creates a CloudStoreCreateAccepted with default headers values
func NewCloudStoreCreateAccepted() *CloudStoreCreateAccepted {
	return &CloudStoreCreateAccepted{}
}

/*
CloudStoreCreateAccepted describes a response with status code 202, with default header values.

Accepted
*/
type CloudStoreCreateAccepted struct {

	/* Useful for tracking the resource location
	 */
	Location string

	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this cloud store create accepted response has a 2xx status code
func (o *CloudStoreCreateAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this cloud store create accepted response has a 3xx status code
func (o *CloudStoreCreateAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this cloud store create accepted response has a 4xx status code
func (o *CloudStoreCreateAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this cloud store create accepted response has a 5xx status code
func (o *CloudStoreCreateAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this cloud store create accepted response a status code equal to that given
func (o *CloudStoreCreateAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *CloudStoreCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /storage/aggregates/{aggregate.uuid}/cloud-stores][%d] cloudStoreCreateAccepted  %+v", 202, o.Payload)
}

func (o *CloudStoreCreateAccepted) String() string {
	return fmt.Sprintf("[POST /storage/aggregates/{aggregate.uuid}/cloud-stores][%d] cloudStoreCreateAccepted  %+v", 202, o.Payload)
}

func (o *CloudStoreCreateAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *CloudStoreCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCloudStoreCreateDefault creates a CloudStoreCreateDefault with default headers values
func NewCloudStoreCreateDefault(code int) *CloudStoreCreateDefault {
	return &CloudStoreCreateDefault{
		_statusCode: code,
	}
}

/*
CloudStoreCreateDefault describes a response with status code -1, with default header values.

Error
*/
type CloudStoreCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the cloud store create default response
func (o *CloudStoreCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this cloud store create default response has a 2xx status code
func (o *CloudStoreCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this cloud store create default response has a 3xx status code
func (o *CloudStoreCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this cloud store create default response has a 4xx status code
func (o *CloudStoreCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this cloud store create default response has a 5xx status code
func (o *CloudStoreCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this cloud store create default response a status code equal to that given
func (o *CloudStoreCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *CloudStoreCreateDefault) Error() string {
	return fmt.Sprintf("[POST /storage/aggregates/{aggregate.uuid}/cloud-stores][%d] cloud_store_create default  %+v", o._statusCode, o.Payload)
}

func (o *CloudStoreCreateDefault) String() string {
	return fmt.Sprintf("[POST /storage/aggregates/{aggregate.uuid}/cloud-stores][%d] cloud_store_create default  %+v", o._statusCode, o.Payload)
}

func (o *CloudStoreCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *CloudStoreCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
