// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// CloudStoreGetReader is a Reader for the CloudStoreGet structure.
type CloudStoreGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CloudStoreGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCloudStoreGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewCloudStoreGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCloudStoreGetOK creates a CloudStoreGetOK with default headers values
func NewCloudStoreGetOK() *CloudStoreGetOK {
	return &CloudStoreGetOK{}
}

/*
CloudStoreGetOK describes a response with status code 200, with default header values.

OK
*/
type CloudStoreGetOK struct {
	Payload *models.CloudStore
}

// IsSuccess returns true when this cloud store get o k response has a 2xx status code
func (o *CloudStoreGetOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this cloud store get o k response has a 3xx status code
func (o *CloudStoreGetOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this cloud store get o k response has a 4xx status code
func (o *CloudStoreGetOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this cloud store get o k response has a 5xx status code
func (o *CloudStoreGetOK) IsServerError() bool {
	return false
}

// IsCode returns true when this cloud store get o k response a status code equal to that given
func (o *CloudStoreGetOK) IsCode(code int) bool {
	return code == 200
}

func (o *CloudStoreGetOK) Error() string {
	return fmt.Sprintf("[GET /storage/aggregates/{aggregate.uuid}/cloud-stores/{target.uuid}][%d] cloudStoreGetOK  %+v", 200, o.Payload)
}

func (o *CloudStoreGetOK) String() string {
	return fmt.Sprintf("[GET /storage/aggregates/{aggregate.uuid}/cloud-stores/{target.uuid}][%d] cloudStoreGetOK  %+v", 200, o.Payload)
}

func (o *CloudStoreGetOK) GetPayload() *models.CloudStore {
	return o.Payload
}

func (o *CloudStoreGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.CloudStore)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCloudStoreGetDefault creates a CloudStoreGetDefault with default headers values
func NewCloudStoreGetDefault(code int) *CloudStoreGetDefault {
	return &CloudStoreGetDefault{
		_statusCode: code,
	}
}

/*
CloudStoreGetDefault describes a response with status code -1, with default header values.

Error
*/
type CloudStoreGetDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the cloud store get default response
func (o *CloudStoreGetDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this cloud store get default response has a 2xx status code
func (o *CloudStoreGetDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this cloud store get default response has a 3xx status code
func (o *CloudStoreGetDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this cloud store get default response has a 4xx status code
func (o *CloudStoreGetDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this cloud store get default response has a 5xx status code
func (o *CloudStoreGetDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this cloud store get default response a status code equal to that given
func (o *CloudStoreGetDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *CloudStoreGetDefault) Error() string {
	return fmt.Sprintf("[GET /storage/aggregates/{aggregate.uuid}/cloud-stores/{target.uuid}][%d] cloud_store_get default  %+v", o._statusCode, o.Payload)
}

func (o *CloudStoreGetDefault) String() string {
	return fmt.Sprintf("[GET /storage/aggregates/{aggregate.uuid}/cloud-stores/{target.uuid}][%d] cloud_store_get default  %+v", o._statusCode, o.Payload)
}

func (o *CloudStoreGetDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *CloudStoreGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
