// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewStoragePoolCollectionGetParams creates a new StoragePoolCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStoragePoolCollectionGetParams() *StoragePoolCollectionGetParams {
	return &StoragePoolCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStoragePoolCollectionGetParamsWithTimeout creates a new StoragePoolCollectionGetParams object
// with the ability to set a timeout on a request.
func NewStoragePoolCollectionGetParamsWithTimeout(timeout time.Duration) *StoragePoolCollectionGetParams {
	return &StoragePoolCollectionGetParams{
		timeout: timeout,
	}
}

// NewStoragePoolCollectionGetParamsWithContext creates a new StoragePoolCollectionGetParams object
// with the ability to set a context for a request.
func NewStoragePoolCollectionGetParamsWithContext(ctx context.Context) *StoragePoolCollectionGetParams {
	return &StoragePoolCollectionGetParams{
		Context: ctx,
	}
}

// NewStoragePoolCollectionGetParamsWithHTTPClient creates a new StoragePoolCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewStoragePoolCollectionGetParamsWithHTTPClient(client *http.Client) *StoragePoolCollectionGetParams {
	return &StoragePoolCollectionGetParams{
		HTTPClient: client,
	}
}

/*
StoragePoolCollectionGetParams contains all the parameters to send to the API endpoint

	for the storage pool collection get operation.

	Typically these are written to a http.Request.
*/
type StoragePoolCollectionGetParams struct {

	/* CapacityDiskCount.

	   Filter by capacity.disk_count
	*/
	CapacityDiskCount *int64

	/* CapacityDisksDiskName.

	   Filter by capacity.disks.disk.name
	*/
	CapacityDisksDiskName *string

	/* CapacityDisksTotalSize.

	   Filter by capacity.disks.total_size
	*/
	CapacityDisksTotalSize *int64

	/* CapacityDisksUsableSize.

	   Filter by capacity.disks.usable_size
	*/
	CapacityDisksUsableSize *int64

	/* CapacityRemaining.

	   Filter by capacity.remaining
	*/
	CapacityRemaining *int64

	/* CapacitySpareAllocationUnitsAvailableSize.

	   Filter by capacity.spare_allocation_units.available_size
	*/
	CapacitySpareAllocationUnitsAvailableSize *int64

	/* CapacitySpareAllocationUnitsCount.

	   Filter by capacity.spare_allocation_units.count
	*/
	CapacitySpareAllocationUnitsCount *int64

	/* CapacitySpareAllocationUnitsNodeName.

	   Filter by capacity.spare_allocation_units.node.name
	*/
	CapacitySpareAllocationUnitsNodeName *string

	/* CapacitySpareAllocationUnitsNodeUUID.

	   Filter by capacity.spare_allocation_units.node.uuid
	*/
	CapacitySpareAllocationUnitsNodeUUID *string

	/* CapacitySpareAllocationUnitsSize.

	   Filter by capacity.spare_allocation_units.size
	*/
	CapacitySpareAllocationUnitsSize *int64

	/* CapacitySpareAllocationUnitsSyncmirrorPool.

	   Filter by capacity.spare_allocation_units.syncmirror_pool
	*/
	CapacitySpareAllocationUnitsSyncmirrorPool *string

	/* CapacityTotal.

	   Filter by capacity.total
	*/
	CapacityTotal *int64

	/* CapacityUsedAllocationUnitsAggregateName.

	   Filter by capacity.used_allocation_units.aggregate.name
	*/
	CapacityUsedAllocationUnitsAggregateName *string

	/* CapacityUsedAllocationUnitsAggregateUUID.

	   Filter by capacity.used_allocation_units.aggregate.uuid
	*/
	CapacityUsedAllocationUnitsAggregateUUID *string

	/* CapacityUsedAllocationUnitsCount.

	   Filter by capacity.used_allocation_units.count
	*/
	CapacityUsedAllocationUnitsCount *int64

	/* CapacityUsedAllocationUnitsCurrentUsage.

	   Filter by capacity.used_allocation_units.current_usage
	*/
	CapacityUsedAllocationUnitsCurrentUsage *int64

	/* CapacityUsedAllocationUnitsNodeName.

	   Filter by capacity.used_allocation_units.node.name
	*/
	CapacityUsedAllocationUnitsNodeName *string

	/* CapacityUsedAllocationUnitsNodeUUID.

	   Filter by capacity.used_allocation_units.node.uuid
	*/
	CapacityUsedAllocationUnitsNodeUUID *string

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* HealthIsHealthy.

	   Filter by health.is_healthy
	*/
	HealthIsHealthy *bool

	/* HealthState.

	   Filter by health.state
	*/
	HealthState *string

	/* HealthUnhealthyReasonArgumentsCode.

	   Filter by health.unhealthy_reason.arguments.code
	*/
	HealthUnhealthyReasonArgumentsCode *string

	/* HealthUnhealthyReasonArgumentsMessage.

	   Filter by health.unhealthy_reason.arguments.message
	*/
	HealthUnhealthyReasonArgumentsMessage *string

	/* HealthUnhealthyReasonCode.

	   Filter by health.unhealthy_reason.code
	*/
	HealthUnhealthyReasonCode *string

	/* HealthUnhealthyReasonMessage.

	   Filter by health.unhealthy_reason.message
	*/
	HealthUnhealthyReasonMessage *string

	/* HealthUnhealthyReasonTarget.

	   Filter by health.unhealthy_reason.target
	*/
	HealthUnhealthyReasonTarget *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Name.

	   Filter by name
	*/
	Name *string

	/* NodesName.

	   Filter by nodes.name
	*/
	NodesName *string

	/* NodesUUID.

	   Filter by nodes.uuid
	*/
	NodesUUID *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* StorageType.

	   Filter by storage_type
	*/
	StorageType *string

	/* UUID.

	   Filter by uuid
	*/
	UUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the storage pool collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StoragePoolCollectionGetParams) WithDefaults() *StoragePoolCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the storage pool collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StoragePoolCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := StoragePoolCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithTimeout(timeout time.Duration) *StoragePoolCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithContext(ctx context.Context) *StoragePoolCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHTTPClient(client *http.Client) *StoragePoolCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCapacityDiskCount adds the capacityDiskCount to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityDiskCount(capacityDiskCount *int64) *StoragePoolCollectionGetParams {
	o.SetCapacityDiskCount(capacityDiskCount)
	return o
}

// SetCapacityDiskCount adds the capacityDiskCount to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityDiskCount(capacityDiskCount *int64) {
	o.CapacityDiskCount = capacityDiskCount
}

// WithCapacityDisksDiskName adds the capacityDisksDiskName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityDisksDiskName(capacityDisksDiskName *string) *StoragePoolCollectionGetParams {
	o.SetCapacityDisksDiskName(capacityDisksDiskName)
	return o
}

// SetCapacityDisksDiskName adds the capacityDisksDiskName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityDisksDiskName(capacityDisksDiskName *string) {
	o.CapacityDisksDiskName = capacityDisksDiskName
}

// WithCapacityDisksTotalSize adds the capacityDisksTotalSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityDisksTotalSize(capacityDisksTotalSize *int64) *StoragePoolCollectionGetParams {
	o.SetCapacityDisksTotalSize(capacityDisksTotalSize)
	return o
}

// SetCapacityDisksTotalSize adds the capacityDisksTotalSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityDisksTotalSize(capacityDisksTotalSize *int64) {
	o.CapacityDisksTotalSize = capacityDisksTotalSize
}

// WithCapacityDisksUsableSize adds the capacityDisksUsableSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityDisksUsableSize(capacityDisksUsableSize *int64) *StoragePoolCollectionGetParams {
	o.SetCapacityDisksUsableSize(capacityDisksUsableSize)
	return o
}

// SetCapacityDisksUsableSize adds the capacityDisksUsableSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityDisksUsableSize(capacityDisksUsableSize *int64) {
	o.CapacityDisksUsableSize = capacityDisksUsableSize
}

// WithCapacityRemaining adds the capacityRemaining to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityRemaining(capacityRemaining *int64) *StoragePoolCollectionGetParams {
	o.SetCapacityRemaining(capacityRemaining)
	return o
}

// SetCapacityRemaining adds the capacityRemaining to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityRemaining(capacityRemaining *int64) {
	o.CapacityRemaining = capacityRemaining
}

// WithCapacitySpareAllocationUnitsAvailableSize adds the capacitySpareAllocationUnitsAvailableSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacitySpareAllocationUnitsAvailableSize(capacitySpareAllocationUnitsAvailableSize *int64) *StoragePoolCollectionGetParams {
	o.SetCapacitySpareAllocationUnitsAvailableSize(capacitySpareAllocationUnitsAvailableSize)
	return o
}

// SetCapacitySpareAllocationUnitsAvailableSize adds the capacitySpareAllocationUnitsAvailableSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacitySpareAllocationUnitsAvailableSize(capacitySpareAllocationUnitsAvailableSize *int64) {
	o.CapacitySpareAllocationUnitsAvailableSize = capacitySpareAllocationUnitsAvailableSize
}

// WithCapacitySpareAllocationUnitsCount adds the capacitySpareAllocationUnitsCount to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacitySpareAllocationUnitsCount(capacitySpareAllocationUnitsCount *int64) *StoragePoolCollectionGetParams {
	o.SetCapacitySpareAllocationUnitsCount(capacitySpareAllocationUnitsCount)
	return o
}

// SetCapacitySpareAllocationUnitsCount adds the capacitySpareAllocationUnitsCount to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacitySpareAllocationUnitsCount(capacitySpareAllocationUnitsCount *int64) {
	o.CapacitySpareAllocationUnitsCount = capacitySpareAllocationUnitsCount
}

// WithCapacitySpareAllocationUnitsNodeName adds the capacitySpareAllocationUnitsNodeName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacitySpareAllocationUnitsNodeName(capacitySpareAllocationUnitsNodeName *string) *StoragePoolCollectionGetParams {
	o.SetCapacitySpareAllocationUnitsNodeName(capacitySpareAllocationUnitsNodeName)
	return o
}

// SetCapacitySpareAllocationUnitsNodeName adds the capacitySpareAllocationUnitsNodeName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacitySpareAllocationUnitsNodeName(capacitySpareAllocationUnitsNodeName *string) {
	o.CapacitySpareAllocationUnitsNodeName = capacitySpareAllocationUnitsNodeName
}

// WithCapacitySpareAllocationUnitsNodeUUID adds the capacitySpareAllocationUnitsNodeUUID to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacitySpareAllocationUnitsNodeUUID(capacitySpareAllocationUnitsNodeUUID *string) *StoragePoolCollectionGetParams {
	o.SetCapacitySpareAllocationUnitsNodeUUID(capacitySpareAllocationUnitsNodeUUID)
	return o
}

// SetCapacitySpareAllocationUnitsNodeUUID adds the capacitySpareAllocationUnitsNodeUuid to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacitySpareAllocationUnitsNodeUUID(capacitySpareAllocationUnitsNodeUUID *string) {
	o.CapacitySpareAllocationUnitsNodeUUID = capacitySpareAllocationUnitsNodeUUID
}

// WithCapacitySpareAllocationUnitsSize adds the capacitySpareAllocationUnitsSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacitySpareAllocationUnitsSize(capacitySpareAllocationUnitsSize *int64) *StoragePoolCollectionGetParams {
	o.SetCapacitySpareAllocationUnitsSize(capacitySpareAllocationUnitsSize)
	return o
}

// SetCapacitySpareAllocationUnitsSize adds the capacitySpareAllocationUnitsSize to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacitySpareAllocationUnitsSize(capacitySpareAllocationUnitsSize *int64) {
	o.CapacitySpareAllocationUnitsSize = capacitySpareAllocationUnitsSize
}

// WithCapacitySpareAllocationUnitsSyncmirrorPool adds the capacitySpareAllocationUnitsSyncmirrorPool to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacitySpareAllocationUnitsSyncmirrorPool(capacitySpareAllocationUnitsSyncmirrorPool *string) *StoragePoolCollectionGetParams {
	o.SetCapacitySpareAllocationUnitsSyncmirrorPool(capacitySpareAllocationUnitsSyncmirrorPool)
	return o
}

// SetCapacitySpareAllocationUnitsSyncmirrorPool adds the capacitySpareAllocationUnitsSyncmirrorPool to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacitySpareAllocationUnitsSyncmirrorPool(capacitySpareAllocationUnitsSyncmirrorPool *string) {
	o.CapacitySpareAllocationUnitsSyncmirrorPool = capacitySpareAllocationUnitsSyncmirrorPool
}

// WithCapacityTotal adds the capacityTotal to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityTotal(capacityTotal *int64) *StoragePoolCollectionGetParams {
	o.SetCapacityTotal(capacityTotal)
	return o
}

// SetCapacityTotal adds the capacityTotal to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityTotal(capacityTotal *int64) {
	o.CapacityTotal = capacityTotal
}

// WithCapacityUsedAllocationUnitsAggregateName adds the capacityUsedAllocationUnitsAggregateName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityUsedAllocationUnitsAggregateName(capacityUsedAllocationUnitsAggregateName *string) *StoragePoolCollectionGetParams {
	o.SetCapacityUsedAllocationUnitsAggregateName(capacityUsedAllocationUnitsAggregateName)
	return o
}

// SetCapacityUsedAllocationUnitsAggregateName adds the capacityUsedAllocationUnitsAggregateName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityUsedAllocationUnitsAggregateName(capacityUsedAllocationUnitsAggregateName *string) {
	o.CapacityUsedAllocationUnitsAggregateName = capacityUsedAllocationUnitsAggregateName
}

// WithCapacityUsedAllocationUnitsAggregateUUID adds the capacityUsedAllocationUnitsAggregateUUID to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityUsedAllocationUnitsAggregateUUID(capacityUsedAllocationUnitsAggregateUUID *string) *StoragePoolCollectionGetParams {
	o.SetCapacityUsedAllocationUnitsAggregateUUID(capacityUsedAllocationUnitsAggregateUUID)
	return o
}

// SetCapacityUsedAllocationUnitsAggregateUUID adds the capacityUsedAllocationUnitsAggregateUuid to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityUsedAllocationUnitsAggregateUUID(capacityUsedAllocationUnitsAggregateUUID *string) {
	o.CapacityUsedAllocationUnitsAggregateUUID = capacityUsedAllocationUnitsAggregateUUID
}

// WithCapacityUsedAllocationUnitsCount adds the capacityUsedAllocationUnitsCount to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityUsedAllocationUnitsCount(capacityUsedAllocationUnitsCount *int64) *StoragePoolCollectionGetParams {
	o.SetCapacityUsedAllocationUnitsCount(capacityUsedAllocationUnitsCount)
	return o
}

// SetCapacityUsedAllocationUnitsCount adds the capacityUsedAllocationUnitsCount to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityUsedAllocationUnitsCount(capacityUsedAllocationUnitsCount *int64) {
	o.CapacityUsedAllocationUnitsCount = capacityUsedAllocationUnitsCount
}

// WithCapacityUsedAllocationUnitsCurrentUsage adds the capacityUsedAllocationUnitsCurrentUsage to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityUsedAllocationUnitsCurrentUsage(capacityUsedAllocationUnitsCurrentUsage *int64) *StoragePoolCollectionGetParams {
	o.SetCapacityUsedAllocationUnitsCurrentUsage(capacityUsedAllocationUnitsCurrentUsage)
	return o
}

// SetCapacityUsedAllocationUnitsCurrentUsage adds the capacityUsedAllocationUnitsCurrentUsage to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityUsedAllocationUnitsCurrentUsage(capacityUsedAllocationUnitsCurrentUsage *int64) {
	o.CapacityUsedAllocationUnitsCurrentUsage = capacityUsedAllocationUnitsCurrentUsage
}

// WithCapacityUsedAllocationUnitsNodeName adds the capacityUsedAllocationUnitsNodeName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityUsedAllocationUnitsNodeName(capacityUsedAllocationUnitsNodeName *string) *StoragePoolCollectionGetParams {
	o.SetCapacityUsedAllocationUnitsNodeName(capacityUsedAllocationUnitsNodeName)
	return o
}

// SetCapacityUsedAllocationUnitsNodeName adds the capacityUsedAllocationUnitsNodeName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityUsedAllocationUnitsNodeName(capacityUsedAllocationUnitsNodeName *string) {
	o.CapacityUsedAllocationUnitsNodeName = capacityUsedAllocationUnitsNodeName
}

// WithCapacityUsedAllocationUnitsNodeUUID adds the capacityUsedAllocationUnitsNodeUUID to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithCapacityUsedAllocationUnitsNodeUUID(capacityUsedAllocationUnitsNodeUUID *string) *StoragePoolCollectionGetParams {
	o.SetCapacityUsedAllocationUnitsNodeUUID(capacityUsedAllocationUnitsNodeUUID)
	return o
}

// SetCapacityUsedAllocationUnitsNodeUUID adds the capacityUsedAllocationUnitsNodeUuid to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetCapacityUsedAllocationUnitsNodeUUID(capacityUsedAllocationUnitsNodeUUID *string) {
	o.CapacityUsedAllocationUnitsNodeUUID = capacityUsedAllocationUnitsNodeUUID
}

// WithFields adds the fields to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithFields(fields []string) *StoragePoolCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithHealthIsHealthy adds the healthIsHealthy to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHealthIsHealthy(healthIsHealthy *bool) *StoragePoolCollectionGetParams {
	o.SetHealthIsHealthy(healthIsHealthy)
	return o
}

// SetHealthIsHealthy adds the healthIsHealthy to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHealthIsHealthy(healthIsHealthy *bool) {
	o.HealthIsHealthy = healthIsHealthy
}

// WithHealthState adds the healthState to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHealthState(healthState *string) *StoragePoolCollectionGetParams {
	o.SetHealthState(healthState)
	return o
}

// SetHealthState adds the healthState to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHealthState(healthState *string) {
	o.HealthState = healthState
}

// WithHealthUnhealthyReasonArgumentsCode adds the healthUnhealthyReasonArgumentsCode to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHealthUnhealthyReasonArgumentsCode(healthUnhealthyReasonArgumentsCode *string) *StoragePoolCollectionGetParams {
	o.SetHealthUnhealthyReasonArgumentsCode(healthUnhealthyReasonArgumentsCode)
	return o
}

// SetHealthUnhealthyReasonArgumentsCode adds the healthUnhealthyReasonArgumentsCode to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHealthUnhealthyReasonArgumentsCode(healthUnhealthyReasonArgumentsCode *string) {
	o.HealthUnhealthyReasonArgumentsCode = healthUnhealthyReasonArgumentsCode
}

// WithHealthUnhealthyReasonArgumentsMessage adds the healthUnhealthyReasonArgumentsMessage to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHealthUnhealthyReasonArgumentsMessage(healthUnhealthyReasonArgumentsMessage *string) *StoragePoolCollectionGetParams {
	o.SetHealthUnhealthyReasonArgumentsMessage(healthUnhealthyReasonArgumentsMessage)
	return o
}

// SetHealthUnhealthyReasonArgumentsMessage adds the healthUnhealthyReasonArgumentsMessage to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHealthUnhealthyReasonArgumentsMessage(healthUnhealthyReasonArgumentsMessage *string) {
	o.HealthUnhealthyReasonArgumentsMessage = healthUnhealthyReasonArgumentsMessage
}

// WithHealthUnhealthyReasonCode adds the healthUnhealthyReasonCode to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHealthUnhealthyReasonCode(healthUnhealthyReasonCode *string) *StoragePoolCollectionGetParams {
	o.SetHealthUnhealthyReasonCode(healthUnhealthyReasonCode)
	return o
}

// SetHealthUnhealthyReasonCode adds the healthUnhealthyReasonCode to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHealthUnhealthyReasonCode(healthUnhealthyReasonCode *string) {
	o.HealthUnhealthyReasonCode = healthUnhealthyReasonCode
}

// WithHealthUnhealthyReasonMessage adds the healthUnhealthyReasonMessage to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHealthUnhealthyReasonMessage(healthUnhealthyReasonMessage *string) *StoragePoolCollectionGetParams {
	o.SetHealthUnhealthyReasonMessage(healthUnhealthyReasonMessage)
	return o
}

// SetHealthUnhealthyReasonMessage adds the healthUnhealthyReasonMessage to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHealthUnhealthyReasonMessage(healthUnhealthyReasonMessage *string) {
	o.HealthUnhealthyReasonMessage = healthUnhealthyReasonMessage
}

// WithHealthUnhealthyReasonTarget adds the healthUnhealthyReasonTarget to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithHealthUnhealthyReasonTarget(healthUnhealthyReasonTarget *string) *StoragePoolCollectionGetParams {
	o.SetHealthUnhealthyReasonTarget(healthUnhealthyReasonTarget)
	return o
}

// SetHealthUnhealthyReasonTarget adds the healthUnhealthyReasonTarget to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetHealthUnhealthyReasonTarget(healthUnhealthyReasonTarget *string) {
	o.HealthUnhealthyReasonTarget = healthUnhealthyReasonTarget
}

// WithMaxRecords adds the maxRecords to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithMaxRecords(maxRecords *int64) *StoragePoolCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithName(name *string) *StoragePoolCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithNodesName adds the nodesName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithNodesName(nodesName *string) *StoragePoolCollectionGetParams {
	o.SetNodesName(nodesName)
	return o
}

// SetNodesName adds the nodesName to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetNodesName(nodesName *string) {
	o.NodesName = nodesName
}

// WithNodesUUID adds the nodesUUID to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithNodesUUID(nodesUUID *string) *StoragePoolCollectionGetParams {
	o.SetNodesUUID(nodesUUID)
	return o
}

// SetNodesUUID adds the nodesUuid to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetNodesUUID(nodesUUID *string) {
	o.NodesUUID = nodesUUID
}

// WithOrderBy adds the orderBy to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithOrderBy(orderBy []string) *StoragePoolCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithReturnRecords(returnRecords *bool) *StoragePoolCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *StoragePoolCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithStorageType adds the storageType to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithStorageType(storageType *string) *StoragePoolCollectionGetParams {
	o.SetStorageType(storageType)
	return o
}

// SetStorageType adds the storageType to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetStorageType(storageType *string) {
	o.StorageType = storageType
}

// WithUUID adds the uuid to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) WithUUID(uuid *string) *StoragePoolCollectionGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the storage pool collection get params
func (o *StoragePoolCollectionGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *StoragePoolCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CapacityDiskCount != nil {

		// query param capacity.disk_count
		var qrCapacityDiskCount int64

		if o.CapacityDiskCount != nil {
			qrCapacityDiskCount = *o.CapacityDiskCount
		}
		qCapacityDiskCount := swag.FormatInt64(qrCapacityDiskCount)
		if qCapacityDiskCount != "" {

			if err := r.SetQueryParam("capacity.disk_count", qCapacityDiskCount); err != nil {
				return err
			}
		}
	}

	if o.CapacityDisksDiskName != nil {

		// query param capacity.disks.disk.name
		var qrCapacityDisksDiskName string

		if o.CapacityDisksDiskName != nil {
			qrCapacityDisksDiskName = *o.CapacityDisksDiskName
		}
		qCapacityDisksDiskName := qrCapacityDisksDiskName
		if qCapacityDisksDiskName != "" {

			if err := r.SetQueryParam("capacity.disks.disk.name", qCapacityDisksDiskName); err != nil {
				return err
			}
		}
	}

	if o.CapacityDisksTotalSize != nil {

		// query param capacity.disks.total_size
		var qrCapacityDisksTotalSize int64

		if o.CapacityDisksTotalSize != nil {
			qrCapacityDisksTotalSize = *o.CapacityDisksTotalSize
		}
		qCapacityDisksTotalSize := swag.FormatInt64(qrCapacityDisksTotalSize)
		if qCapacityDisksTotalSize != "" {

			if err := r.SetQueryParam("capacity.disks.total_size", qCapacityDisksTotalSize); err != nil {
				return err
			}
		}
	}

	if o.CapacityDisksUsableSize != nil {

		// query param capacity.disks.usable_size
		var qrCapacityDisksUsableSize int64

		if o.CapacityDisksUsableSize != nil {
			qrCapacityDisksUsableSize = *o.CapacityDisksUsableSize
		}
		qCapacityDisksUsableSize := swag.FormatInt64(qrCapacityDisksUsableSize)
		if qCapacityDisksUsableSize != "" {

			if err := r.SetQueryParam("capacity.disks.usable_size", qCapacityDisksUsableSize); err != nil {
				return err
			}
		}
	}

	if o.CapacityRemaining != nil {

		// query param capacity.remaining
		var qrCapacityRemaining int64

		if o.CapacityRemaining != nil {
			qrCapacityRemaining = *o.CapacityRemaining
		}
		qCapacityRemaining := swag.FormatInt64(qrCapacityRemaining)
		if qCapacityRemaining != "" {

			if err := r.SetQueryParam("capacity.remaining", qCapacityRemaining); err != nil {
				return err
			}
		}
	}

	if o.CapacitySpareAllocationUnitsAvailableSize != nil {

		// query param capacity.spare_allocation_units.available_size
		var qrCapacitySpareAllocationUnitsAvailableSize int64

		if o.CapacitySpareAllocationUnitsAvailableSize != nil {
			qrCapacitySpareAllocationUnitsAvailableSize = *o.CapacitySpareAllocationUnitsAvailableSize
		}
		qCapacitySpareAllocationUnitsAvailableSize := swag.FormatInt64(qrCapacitySpareAllocationUnitsAvailableSize)
		if qCapacitySpareAllocationUnitsAvailableSize != "" {

			if err := r.SetQueryParam("capacity.spare_allocation_units.available_size", qCapacitySpareAllocationUnitsAvailableSize); err != nil {
				return err
			}
		}
	}

	if o.CapacitySpareAllocationUnitsCount != nil {

		// query param capacity.spare_allocation_units.count
		var qrCapacitySpareAllocationUnitsCount int64

		if o.CapacitySpareAllocationUnitsCount != nil {
			qrCapacitySpareAllocationUnitsCount = *o.CapacitySpareAllocationUnitsCount
		}
		qCapacitySpareAllocationUnitsCount := swag.FormatInt64(qrCapacitySpareAllocationUnitsCount)
		if qCapacitySpareAllocationUnitsCount != "" {

			if err := r.SetQueryParam("capacity.spare_allocation_units.count", qCapacitySpareAllocationUnitsCount); err != nil {
				return err
			}
		}
	}

	if o.CapacitySpareAllocationUnitsNodeName != nil {

		// query param capacity.spare_allocation_units.node.name
		var qrCapacitySpareAllocationUnitsNodeName string

		if o.CapacitySpareAllocationUnitsNodeName != nil {
			qrCapacitySpareAllocationUnitsNodeName = *o.CapacitySpareAllocationUnitsNodeName
		}
		qCapacitySpareAllocationUnitsNodeName := qrCapacitySpareAllocationUnitsNodeName
		if qCapacitySpareAllocationUnitsNodeName != "" {

			if err := r.SetQueryParam("capacity.spare_allocation_units.node.name", qCapacitySpareAllocationUnitsNodeName); err != nil {
				return err
			}
		}
	}

	if o.CapacitySpareAllocationUnitsNodeUUID != nil {

		// query param capacity.spare_allocation_units.node.uuid
		var qrCapacitySpareAllocationUnitsNodeUUID string

		if o.CapacitySpareAllocationUnitsNodeUUID != nil {
			qrCapacitySpareAllocationUnitsNodeUUID = *o.CapacitySpareAllocationUnitsNodeUUID
		}
		qCapacitySpareAllocationUnitsNodeUUID := qrCapacitySpareAllocationUnitsNodeUUID
		if qCapacitySpareAllocationUnitsNodeUUID != "" {

			if err := r.SetQueryParam("capacity.spare_allocation_units.node.uuid", qCapacitySpareAllocationUnitsNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.CapacitySpareAllocationUnitsSize != nil {

		// query param capacity.spare_allocation_units.size
		var qrCapacitySpareAllocationUnitsSize int64

		if o.CapacitySpareAllocationUnitsSize != nil {
			qrCapacitySpareAllocationUnitsSize = *o.CapacitySpareAllocationUnitsSize
		}
		qCapacitySpareAllocationUnitsSize := swag.FormatInt64(qrCapacitySpareAllocationUnitsSize)
		if qCapacitySpareAllocationUnitsSize != "" {

			if err := r.SetQueryParam("capacity.spare_allocation_units.size", qCapacitySpareAllocationUnitsSize); err != nil {
				return err
			}
		}
	}

	if o.CapacitySpareAllocationUnitsSyncmirrorPool != nil {

		// query param capacity.spare_allocation_units.syncmirror_pool
		var qrCapacitySpareAllocationUnitsSyncmirrorPool string

		if o.CapacitySpareAllocationUnitsSyncmirrorPool != nil {
			qrCapacitySpareAllocationUnitsSyncmirrorPool = *o.CapacitySpareAllocationUnitsSyncmirrorPool
		}
		qCapacitySpareAllocationUnitsSyncmirrorPool := qrCapacitySpareAllocationUnitsSyncmirrorPool
		if qCapacitySpareAllocationUnitsSyncmirrorPool != "" {

			if err := r.SetQueryParam("capacity.spare_allocation_units.syncmirror_pool", qCapacitySpareAllocationUnitsSyncmirrorPool); err != nil {
				return err
			}
		}
	}

	if o.CapacityTotal != nil {

		// query param capacity.total
		var qrCapacityTotal int64

		if o.CapacityTotal != nil {
			qrCapacityTotal = *o.CapacityTotal
		}
		qCapacityTotal := swag.FormatInt64(qrCapacityTotal)
		if qCapacityTotal != "" {

			if err := r.SetQueryParam("capacity.total", qCapacityTotal); err != nil {
				return err
			}
		}
	}

	if o.CapacityUsedAllocationUnitsAggregateName != nil {

		// query param capacity.used_allocation_units.aggregate.name
		var qrCapacityUsedAllocationUnitsAggregateName string

		if o.CapacityUsedAllocationUnitsAggregateName != nil {
			qrCapacityUsedAllocationUnitsAggregateName = *o.CapacityUsedAllocationUnitsAggregateName
		}
		qCapacityUsedAllocationUnitsAggregateName := qrCapacityUsedAllocationUnitsAggregateName
		if qCapacityUsedAllocationUnitsAggregateName != "" {

			if err := r.SetQueryParam("capacity.used_allocation_units.aggregate.name", qCapacityUsedAllocationUnitsAggregateName); err != nil {
				return err
			}
		}
	}

	if o.CapacityUsedAllocationUnitsAggregateUUID != nil {

		// query param capacity.used_allocation_units.aggregate.uuid
		var qrCapacityUsedAllocationUnitsAggregateUUID string

		if o.CapacityUsedAllocationUnitsAggregateUUID != nil {
			qrCapacityUsedAllocationUnitsAggregateUUID = *o.CapacityUsedAllocationUnitsAggregateUUID
		}
		qCapacityUsedAllocationUnitsAggregateUUID := qrCapacityUsedAllocationUnitsAggregateUUID
		if qCapacityUsedAllocationUnitsAggregateUUID != "" {

			if err := r.SetQueryParam("capacity.used_allocation_units.aggregate.uuid", qCapacityUsedAllocationUnitsAggregateUUID); err != nil {
				return err
			}
		}
	}

	if o.CapacityUsedAllocationUnitsCount != nil {

		// query param capacity.used_allocation_units.count
		var qrCapacityUsedAllocationUnitsCount int64

		if o.CapacityUsedAllocationUnitsCount != nil {
			qrCapacityUsedAllocationUnitsCount = *o.CapacityUsedAllocationUnitsCount
		}
		qCapacityUsedAllocationUnitsCount := swag.FormatInt64(qrCapacityUsedAllocationUnitsCount)
		if qCapacityUsedAllocationUnitsCount != "" {

			if err := r.SetQueryParam("capacity.used_allocation_units.count", qCapacityUsedAllocationUnitsCount); err != nil {
				return err
			}
		}
	}

	if o.CapacityUsedAllocationUnitsCurrentUsage != nil {

		// query param capacity.used_allocation_units.current_usage
		var qrCapacityUsedAllocationUnitsCurrentUsage int64

		if o.CapacityUsedAllocationUnitsCurrentUsage != nil {
			qrCapacityUsedAllocationUnitsCurrentUsage = *o.CapacityUsedAllocationUnitsCurrentUsage
		}
		qCapacityUsedAllocationUnitsCurrentUsage := swag.FormatInt64(qrCapacityUsedAllocationUnitsCurrentUsage)
		if qCapacityUsedAllocationUnitsCurrentUsage != "" {

			if err := r.SetQueryParam("capacity.used_allocation_units.current_usage", qCapacityUsedAllocationUnitsCurrentUsage); err != nil {
				return err
			}
		}
	}

	if o.CapacityUsedAllocationUnitsNodeName != nil {

		// query param capacity.used_allocation_units.node.name
		var qrCapacityUsedAllocationUnitsNodeName string

		if o.CapacityUsedAllocationUnitsNodeName != nil {
			qrCapacityUsedAllocationUnitsNodeName = *o.CapacityUsedAllocationUnitsNodeName
		}
		qCapacityUsedAllocationUnitsNodeName := qrCapacityUsedAllocationUnitsNodeName
		if qCapacityUsedAllocationUnitsNodeName != "" {

			if err := r.SetQueryParam("capacity.used_allocation_units.node.name", qCapacityUsedAllocationUnitsNodeName); err != nil {
				return err
			}
		}
	}

	if o.CapacityUsedAllocationUnitsNodeUUID != nil {

		// query param capacity.used_allocation_units.node.uuid
		var qrCapacityUsedAllocationUnitsNodeUUID string

		if o.CapacityUsedAllocationUnitsNodeUUID != nil {
			qrCapacityUsedAllocationUnitsNodeUUID = *o.CapacityUsedAllocationUnitsNodeUUID
		}
		qCapacityUsedAllocationUnitsNodeUUID := qrCapacityUsedAllocationUnitsNodeUUID
		if qCapacityUsedAllocationUnitsNodeUUID != "" {

			if err := r.SetQueryParam("capacity.used_allocation_units.node.uuid", qCapacityUsedAllocationUnitsNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.HealthIsHealthy != nil {

		// query param health.is_healthy
		var qrHealthIsHealthy bool

		if o.HealthIsHealthy != nil {
			qrHealthIsHealthy = *o.HealthIsHealthy
		}
		qHealthIsHealthy := swag.FormatBool(qrHealthIsHealthy)
		if qHealthIsHealthy != "" {

			if err := r.SetQueryParam("health.is_healthy", qHealthIsHealthy); err != nil {
				return err
			}
		}
	}

	if o.HealthState != nil {

		// query param health.state
		var qrHealthState string

		if o.HealthState != nil {
			qrHealthState = *o.HealthState
		}
		qHealthState := qrHealthState
		if qHealthState != "" {

			if err := r.SetQueryParam("health.state", qHealthState); err != nil {
				return err
			}
		}
	}

	if o.HealthUnhealthyReasonArgumentsCode != nil {

		// query param health.unhealthy_reason.arguments.code
		var qrHealthUnhealthyReasonArgumentsCode string

		if o.HealthUnhealthyReasonArgumentsCode != nil {
			qrHealthUnhealthyReasonArgumentsCode = *o.HealthUnhealthyReasonArgumentsCode
		}
		qHealthUnhealthyReasonArgumentsCode := qrHealthUnhealthyReasonArgumentsCode
		if qHealthUnhealthyReasonArgumentsCode != "" {

			if err := r.SetQueryParam("health.unhealthy_reason.arguments.code", qHealthUnhealthyReasonArgumentsCode); err != nil {
				return err
			}
		}
	}

	if o.HealthUnhealthyReasonArgumentsMessage != nil {

		// query param health.unhealthy_reason.arguments.message
		var qrHealthUnhealthyReasonArgumentsMessage string

		if o.HealthUnhealthyReasonArgumentsMessage != nil {
			qrHealthUnhealthyReasonArgumentsMessage = *o.HealthUnhealthyReasonArgumentsMessage
		}
		qHealthUnhealthyReasonArgumentsMessage := qrHealthUnhealthyReasonArgumentsMessage
		if qHealthUnhealthyReasonArgumentsMessage != "" {

			if err := r.SetQueryParam("health.unhealthy_reason.arguments.message", qHealthUnhealthyReasonArgumentsMessage); err != nil {
				return err
			}
		}
	}

	if o.HealthUnhealthyReasonCode != nil {

		// query param health.unhealthy_reason.code
		var qrHealthUnhealthyReasonCode string

		if o.HealthUnhealthyReasonCode != nil {
			qrHealthUnhealthyReasonCode = *o.HealthUnhealthyReasonCode
		}
		qHealthUnhealthyReasonCode := qrHealthUnhealthyReasonCode
		if qHealthUnhealthyReasonCode != "" {

			if err := r.SetQueryParam("health.unhealthy_reason.code", qHealthUnhealthyReasonCode); err != nil {
				return err
			}
		}
	}

	if o.HealthUnhealthyReasonMessage != nil {

		// query param health.unhealthy_reason.message
		var qrHealthUnhealthyReasonMessage string

		if o.HealthUnhealthyReasonMessage != nil {
			qrHealthUnhealthyReasonMessage = *o.HealthUnhealthyReasonMessage
		}
		qHealthUnhealthyReasonMessage := qrHealthUnhealthyReasonMessage
		if qHealthUnhealthyReasonMessage != "" {

			if err := r.SetQueryParam("health.unhealthy_reason.message", qHealthUnhealthyReasonMessage); err != nil {
				return err
			}
		}
	}

	if o.HealthUnhealthyReasonTarget != nil {

		// query param health.unhealthy_reason.target
		var qrHealthUnhealthyReasonTarget string

		if o.HealthUnhealthyReasonTarget != nil {
			qrHealthUnhealthyReasonTarget = *o.HealthUnhealthyReasonTarget
		}
		qHealthUnhealthyReasonTarget := qrHealthUnhealthyReasonTarget
		if qHealthUnhealthyReasonTarget != "" {

			if err := r.SetQueryParam("health.unhealthy_reason.target", qHealthUnhealthyReasonTarget); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NodesName != nil {

		// query param nodes.name
		var qrNodesName string

		if o.NodesName != nil {
			qrNodesName = *o.NodesName
		}
		qNodesName := qrNodesName
		if qNodesName != "" {

			if err := r.SetQueryParam("nodes.name", qNodesName); err != nil {
				return err
			}
		}
	}

	if o.NodesUUID != nil {

		// query param nodes.uuid
		var qrNodesUUID string

		if o.NodesUUID != nil {
			qrNodesUUID = *o.NodesUUID
		}
		qNodesUUID := qrNodesUUID
		if qNodesUUID != "" {

			if err := r.SetQueryParam("nodes.uuid", qNodesUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StorageType != nil {

		// query param storage_type
		var qrStorageType string

		if o.StorageType != nil {
			qrStorageType = *o.StorageType
		}
		qStorageType := qrStorageType
		if qStorageType != "" {

			if err := r.SetQueryParam("storage_type", qStorageType); err != nil {
				return err
			}
		}
	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string

		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamStoragePoolCollectionGet binds the parameter fields
func (o *StoragePoolCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamStoragePoolCollectionGet binds the parameter order_by
func (o *StoragePoolCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
