// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewEmsDestinationCollectionGetParams creates a new EmsDestinationCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewEmsDestinationCollectionGetParams() *EmsDestinationCollectionGetParams {
	return &EmsDestinationCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewEmsDestinationCollectionGetParamsWithTimeout creates a new EmsDestinationCollectionGetParams object
// with the ability to set a timeout on a request.
func NewEmsDestinationCollectionGetParamsWithTimeout(timeout time.Duration) *EmsDestinationCollectionGetParams {
	return &EmsDestinationCollectionGetParams{
		timeout: timeout,
	}
}

// NewEmsDestinationCollectionGetParamsWithContext creates a new EmsDestinationCollectionGetParams object
// with the ability to set a context for a request.
func NewEmsDestinationCollectionGetParamsWithContext(ctx context.Context) *EmsDestinationCollectionGetParams {
	return &EmsDestinationCollectionGetParams{
		Context: ctx,
	}
}

// NewEmsDestinationCollectionGetParamsWithHTTPClient creates a new EmsDestinationCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewEmsDestinationCollectionGetParamsWithHTTPClient(client *http.Client) *EmsDestinationCollectionGetParams {
	return &EmsDestinationCollectionGetParams{
		HTTPClient: client,
	}
}

/*
EmsDestinationCollectionGetParams contains all the parameters to send to the API endpoint

	for the ems destination collection get operation.

	Typically these are written to a http.Request.
*/
type EmsDestinationCollectionGetParams struct {

	/* CertificateCa.

	   Filter by certificate.ca
	*/
	CertificateCa *string

	/* CertificateName.

	   Filter by certificate.name
	*/
	CertificateName *string

	/* CertificateSerialNumber.

	   Filter by certificate.serial_number
	*/
	CertificateSerialNumber *string

	/* ConnectivityErrorsMessageArgumentsCode.

	   Filter by connectivity.errors.message.arguments.code
	*/
	ConnectivityErrorsMessageArgumentsCode *string

	/* ConnectivityErrorsMessageArgumentsMessage.

	   Filter by connectivity.errors.message.arguments.message
	*/
	ConnectivityErrorsMessageArgumentsMessage *string

	/* ConnectivityErrorsMessageCode.

	   Filter by connectivity.errors.message.code
	*/
	ConnectivityErrorsMessageCode *string

	/* ConnectivityErrorsMessageMessage.

	   Filter by connectivity.errors.message.message
	*/
	ConnectivityErrorsMessageMessage *string

	/* ConnectivityErrorsNodeName.

	   Filter by connectivity.errors.node.name
	*/
	ConnectivityErrorsNodeName *string

	/* ConnectivityErrorsNodeUUID.

	   Filter by connectivity.errors.node.uuid
	*/
	ConnectivityErrorsNodeUUID *string

	/* ConnectivityState.

	   Filter by connectivity.state
	*/
	ConnectivityState *string

	/* Destination.

	   Filter by destination
	*/
	Destination *string

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* FiltersName.

	   Filter by filters.name
	*/
	FiltersName *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Name.

	   Filter by name
	*/
	Name *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* SyslogFormatHostnameOverride.

	   Filter by syslog.format.hostname_override
	*/
	SyslogFormatHostnameOverride *string

	/* SyslogFormatMessage.

	   Filter by syslog.format.message
	*/
	SyslogFormatMessage *string

	/* SyslogFormatTimestampOverride.

	   Filter by syslog.format.timestamp_override
	*/
	SyslogFormatTimestampOverride *string

	/* SyslogPort.

	   Filter by syslog.port
	*/
	SyslogPort *int64

	/* SyslogTransport.

	   Filter by syslog.transport
	*/
	SyslogTransport *string

	/* SystemDefined.

	   Filter by system_defined
	*/
	SystemDefined *bool

	/* Type.

	   Filter by type
	*/
	Type *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ems destination collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EmsDestinationCollectionGetParams) WithDefaults() *EmsDestinationCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ems destination collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EmsDestinationCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := EmsDestinationCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithTimeout(timeout time.Duration) *EmsDestinationCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithContext(ctx context.Context) *EmsDestinationCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithHTTPClient(client *http.Client) *EmsDestinationCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCertificateCa adds the certificateCa to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithCertificateCa(certificateCa *string) *EmsDestinationCollectionGetParams {
	o.SetCertificateCa(certificateCa)
	return o
}

// SetCertificateCa adds the certificateCa to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetCertificateCa(certificateCa *string) {
	o.CertificateCa = certificateCa
}

// WithCertificateName adds the certificateName to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithCertificateName(certificateName *string) *EmsDestinationCollectionGetParams {
	o.SetCertificateName(certificateName)
	return o
}

// SetCertificateName adds the certificateName to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetCertificateName(certificateName *string) {
	o.CertificateName = certificateName
}

// WithCertificateSerialNumber adds the certificateSerialNumber to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithCertificateSerialNumber(certificateSerialNumber *string) *EmsDestinationCollectionGetParams {
	o.SetCertificateSerialNumber(certificateSerialNumber)
	return o
}

// SetCertificateSerialNumber adds the certificateSerialNumber to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetCertificateSerialNumber(certificateSerialNumber *string) {
	o.CertificateSerialNumber = certificateSerialNumber
}

// WithConnectivityErrorsMessageArgumentsCode adds the connectivityErrorsMessageArgumentsCode to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithConnectivityErrorsMessageArgumentsCode(connectivityErrorsMessageArgumentsCode *string) *EmsDestinationCollectionGetParams {
	o.SetConnectivityErrorsMessageArgumentsCode(connectivityErrorsMessageArgumentsCode)
	return o
}

// SetConnectivityErrorsMessageArgumentsCode adds the connectivityErrorsMessageArgumentsCode to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetConnectivityErrorsMessageArgumentsCode(connectivityErrorsMessageArgumentsCode *string) {
	o.ConnectivityErrorsMessageArgumentsCode = connectivityErrorsMessageArgumentsCode
}

// WithConnectivityErrorsMessageArgumentsMessage adds the connectivityErrorsMessageArgumentsMessage to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithConnectivityErrorsMessageArgumentsMessage(connectivityErrorsMessageArgumentsMessage *string) *EmsDestinationCollectionGetParams {
	o.SetConnectivityErrorsMessageArgumentsMessage(connectivityErrorsMessageArgumentsMessage)
	return o
}

// SetConnectivityErrorsMessageArgumentsMessage adds the connectivityErrorsMessageArgumentsMessage to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetConnectivityErrorsMessageArgumentsMessage(connectivityErrorsMessageArgumentsMessage *string) {
	o.ConnectivityErrorsMessageArgumentsMessage = connectivityErrorsMessageArgumentsMessage
}

// WithConnectivityErrorsMessageCode adds the connectivityErrorsMessageCode to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithConnectivityErrorsMessageCode(connectivityErrorsMessageCode *string) *EmsDestinationCollectionGetParams {
	o.SetConnectivityErrorsMessageCode(connectivityErrorsMessageCode)
	return o
}

// SetConnectivityErrorsMessageCode adds the connectivityErrorsMessageCode to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetConnectivityErrorsMessageCode(connectivityErrorsMessageCode *string) {
	o.ConnectivityErrorsMessageCode = connectivityErrorsMessageCode
}

// WithConnectivityErrorsMessageMessage adds the connectivityErrorsMessageMessage to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithConnectivityErrorsMessageMessage(connectivityErrorsMessageMessage *string) *EmsDestinationCollectionGetParams {
	o.SetConnectivityErrorsMessageMessage(connectivityErrorsMessageMessage)
	return o
}

// SetConnectivityErrorsMessageMessage adds the connectivityErrorsMessageMessage to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetConnectivityErrorsMessageMessage(connectivityErrorsMessageMessage *string) {
	o.ConnectivityErrorsMessageMessage = connectivityErrorsMessageMessage
}

// WithConnectivityErrorsNodeName adds the connectivityErrorsNodeName to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithConnectivityErrorsNodeName(connectivityErrorsNodeName *string) *EmsDestinationCollectionGetParams {
	o.SetConnectivityErrorsNodeName(connectivityErrorsNodeName)
	return o
}

// SetConnectivityErrorsNodeName adds the connectivityErrorsNodeName to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetConnectivityErrorsNodeName(connectivityErrorsNodeName *string) {
	o.ConnectivityErrorsNodeName = connectivityErrorsNodeName
}

// WithConnectivityErrorsNodeUUID adds the connectivityErrorsNodeUUID to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithConnectivityErrorsNodeUUID(connectivityErrorsNodeUUID *string) *EmsDestinationCollectionGetParams {
	o.SetConnectivityErrorsNodeUUID(connectivityErrorsNodeUUID)
	return o
}

// SetConnectivityErrorsNodeUUID adds the connectivityErrorsNodeUuid to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetConnectivityErrorsNodeUUID(connectivityErrorsNodeUUID *string) {
	o.ConnectivityErrorsNodeUUID = connectivityErrorsNodeUUID
}

// WithConnectivityState adds the connectivityState to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithConnectivityState(connectivityState *string) *EmsDestinationCollectionGetParams {
	o.SetConnectivityState(connectivityState)
	return o
}

// SetConnectivityState adds the connectivityState to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetConnectivityState(connectivityState *string) {
	o.ConnectivityState = connectivityState
}

// WithDestination adds the destination to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithDestination(destination *string) *EmsDestinationCollectionGetParams {
	o.SetDestination(destination)
	return o
}

// SetDestination adds the destination to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetDestination(destination *string) {
	o.Destination = destination
}

// WithFields adds the fields to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithFields(fields []string) *EmsDestinationCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithFiltersName adds the filtersName to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithFiltersName(filtersName *string) *EmsDestinationCollectionGetParams {
	o.SetFiltersName(filtersName)
	return o
}

// SetFiltersName adds the filtersName to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetFiltersName(filtersName *string) {
	o.FiltersName = filtersName
}

// WithMaxRecords adds the maxRecords to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithMaxRecords(maxRecords *int64) *EmsDestinationCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithName(name *string) *EmsDestinationCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithOrderBy(orderBy []string) *EmsDestinationCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithReturnRecords(returnRecords *bool) *EmsDestinationCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *EmsDestinationCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSyslogFormatHostnameOverride adds the syslogFormatHostnameOverride to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithSyslogFormatHostnameOverride(syslogFormatHostnameOverride *string) *EmsDestinationCollectionGetParams {
	o.SetSyslogFormatHostnameOverride(syslogFormatHostnameOverride)
	return o
}

// SetSyslogFormatHostnameOverride adds the syslogFormatHostnameOverride to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetSyslogFormatHostnameOverride(syslogFormatHostnameOverride *string) {
	o.SyslogFormatHostnameOverride = syslogFormatHostnameOverride
}

// WithSyslogFormatMessage adds the syslogFormatMessage to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithSyslogFormatMessage(syslogFormatMessage *string) *EmsDestinationCollectionGetParams {
	o.SetSyslogFormatMessage(syslogFormatMessage)
	return o
}

// SetSyslogFormatMessage adds the syslogFormatMessage to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetSyslogFormatMessage(syslogFormatMessage *string) {
	o.SyslogFormatMessage = syslogFormatMessage
}

// WithSyslogFormatTimestampOverride adds the syslogFormatTimestampOverride to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithSyslogFormatTimestampOverride(syslogFormatTimestampOverride *string) *EmsDestinationCollectionGetParams {
	o.SetSyslogFormatTimestampOverride(syslogFormatTimestampOverride)
	return o
}

// SetSyslogFormatTimestampOverride adds the syslogFormatTimestampOverride to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetSyslogFormatTimestampOverride(syslogFormatTimestampOverride *string) {
	o.SyslogFormatTimestampOverride = syslogFormatTimestampOverride
}

// WithSyslogPort adds the syslogPort to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithSyslogPort(syslogPort *int64) *EmsDestinationCollectionGetParams {
	o.SetSyslogPort(syslogPort)
	return o
}

// SetSyslogPort adds the syslogPort to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetSyslogPort(syslogPort *int64) {
	o.SyslogPort = syslogPort
}

// WithSyslogTransport adds the syslogTransport to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithSyslogTransport(syslogTransport *string) *EmsDestinationCollectionGetParams {
	o.SetSyslogTransport(syslogTransport)
	return o
}

// SetSyslogTransport adds the syslogTransport to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetSyslogTransport(syslogTransport *string) {
	o.SyslogTransport = syslogTransport
}

// WithSystemDefined adds the systemDefined to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithSystemDefined(systemDefined *bool) *EmsDestinationCollectionGetParams {
	o.SetSystemDefined(systemDefined)
	return o
}

// SetSystemDefined adds the systemDefined to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetSystemDefined(systemDefined *bool) {
	o.SystemDefined = systemDefined
}

// WithType adds the typeVar to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) WithType(typeVar *string) *EmsDestinationCollectionGetParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the ems destination collection get params
func (o *EmsDestinationCollectionGetParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WriteToRequest writes these params to a swagger request
func (o *EmsDestinationCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CertificateCa != nil {

		// query param certificate.ca
		var qrCertificateCa string

		if o.CertificateCa != nil {
			qrCertificateCa = *o.CertificateCa
		}
		qCertificateCa := qrCertificateCa
		if qCertificateCa != "" {

			if err := r.SetQueryParam("certificate.ca", qCertificateCa); err != nil {
				return err
			}
		}
	}

	if o.CertificateName != nil {

		// query param certificate.name
		var qrCertificateName string

		if o.CertificateName != nil {
			qrCertificateName = *o.CertificateName
		}
		qCertificateName := qrCertificateName
		if qCertificateName != "" {

			if err := r.SetQueryParam("certificate.name", qCertificateName); err != nil {
				return err
			}
		}
	}

	if o.CertificateSerialNumber != nil {

		// query param certificate.serial_number
		var qrCertificateSerialNumber string

		if o.CertificateSerialNumber != nil {
			qrCertificateSerialNumber = *o.CertificateSerialNumber
		}
		qCertificateSerialNumber := qrCertificateSerialNumber
		if qCertificateSerialNumber != "" {

			if err := r.SetQueryParam("certificate.serial_number", qCertificateSerialNumber); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityErrorsMessageArgumentsCode != nil {

		// query param connectivity.errors.message.arguments.code
		var qrConnectivityErrorsMessageArgumentsCode string

		if o.ConnectivityErrorsMessageArgumentsCode != nil {
			qrConnectivityErrorsMessageArgumentsCode = *o.ConnectivityErrorsMessageArgumentsCode
		}
		qConnectivityErrorsMessageArgumentsCode := qrConnectivityErrorsMessageArgumentsCode
		if qConnectivityErrorsMessageArgumentsCode != "" {

			if err := r.SetQueryParam("connectivity.errors.message.arguments.code", qConnectivityErrorsMessageArgumentsCode); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityErrorsMessageArgumentsMessage != nil {

		// query param connectivity.errors.message.arguments.message
		var qrConnectivityErrorsMessageArgumentsMessage string

		if o.ConnectivityErrorsMessageArgumentsMessage != nil {
			qrConnectivityErrorsMessageArgumentsMessage = *o.ConnectivityErrorsMessageArgumentsMessage
		}
		qConnectivityErrorsMessageArgumentsMessage := qrConnectivityErrorsMessageArgumentsMessage
		if qConnectivityErrorsMessageArgumentsMessage != "" {

			if err := r.SetQueryParam("connectivity.errors.message.arguments.message", qConnectivityErrorsMessageArgumentsMessage); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityErrorsMessageCode != nil {

		// query param connectivity.errors.message.code
		var qrConnectivityErrorsMessageCode string

		if o.ConnectivityErrorsMessageCode != nil {
			qrConnectivityErrorsMessageCode = *o.ConnectivityErrorsMessageCode
		}
		qConnectivityErrorsMessageCode := qrConnectivityErrorsMessageCode
		if qConnectivityErrorsMessageCode != "" {

			if err := r.SetQueryParam("connectivity.errors.message.code", qConnectivityErrorsMessageCode); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityErrorsMessageMessage != nil {

		// query param connectivity.errors.message.message
		var qrConnectivityErrorsMessageMessage string

		if o.ConnectivityErrorsMessageMessage != nil {
			qrConnectivityErrorsMessageMessage = *o.ConnectivityErrorsMessageMessage
		}
		qConnectivityErrorsMessageMessage := qrConnectivityErrorsMessageMessage
		if qConnectivityErrorsMessageMessage != "" {

			if err := r.SetQueryParam("connectivity.errors.message.message", qConnectivityErrorsMessageMessage); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityErrorsNodeName != nil {

		// query param connectivity.errors.node.name
		var qrConnectivityErrorsNodeName string

		if o.ConnectivityErrorsNodeName != nil {
			qrConnectivityErrorsNodeName = *o.ConnectivityErrorsNodeName
		}
		qConnectivityErrorsNodeName := qrConnectivityErrorsNodeName
		if qConnectivityErrorsNodeName != "" {

			if err := r.SetQueryParam("connectivity.errors.node.name", qConnectivityErrorsNodeName); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityErrorsNodeUUID != nil {

		// query param connectivity.errors.node.uuid
		var qrConnectivityErrorsNodeUUID string

		if o.ConnectivityErrorsNodeUUID != nil {
			qrConnectivityErrorsNodeUUID = *o.ConnectivityErrorsNodeUUID
		}
		qConnectivityErrorsNodeUUID := qrConnectivityErrorsNodeUUID
		if qConnectivityErrorsNodeUUID != "" {

			if err := r.SetQueryParam("connectivity.errors.node.uuid", qConnectivityErrorsNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityState != nil {

		// query param connectivity.state
		var qrConnectivityState string

		if o.ConnectivityState != nil {
			qrConnectivityState = *o.ConnectivityState
		}
		qConnectivityState := qrConnectivityState
		if qConnectivityState != "" {

			if err := r.SetQueryParam("connectivity.state", qConnectivityState); err != nil {
				return err
			}
		}
	}

	if o.Destination != nil {

		// query param destination
		var qrDestination string

		if o.Destination != nil {
			qrDestination = *o.Destination
		}
		qDestination := qrDestination
		if qDestination != "" {

			if err := r.SetQueryParam("destination", qDestination); err != nil {
				return err
			}
		}
	}

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.FiltersName != nil {

		// query param filters.name
		var qrFiltersName string

		if o.FiltersName != nil {
			qrFiltersName = *o.FiltersName
		}
		qFiltersName := qrFiltersName
		if qFiltersName != "" {

			if err := r.SetQueryParam("filters.name", qFiltersName); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SyslogFormatHostnameOverride != nil {

		// query param syslog.format.hostname_override
		var qrSyslogFormatHostnameOverride string

		if o.SyslogFormatHostnameOverride != nil {
			qrSyslogFormatHostnameOverride = *o.SyslogFormatHostnameOverride
		}
		qSyslogFormatHostnameOverride := qrSyslogFormatHostnameOverride
		if qSyslogFormatHostnameOverride != "" {

			if err := r.SetQueryParam("syslog.format.hostname_override", qSyslogFormatHostnameOverride); err != nil {
				return err
			}
		}
	}

	if o.SyslogFormatMessage != nil {

		// query param syslog.format.message
		var qrSyslogFormatMessage string

		if o.SyslogFormatMessage != nil {
			qrSyslogFormatMessage = *o.SyslogFormatMessage
		}
		qSyslogFormatMessage := qrSyslogFormatMessage
		if qSyslogFormatMessage != "" {

			if err := r.SetQueryParam("syslog.format.message", qSyslogFormatMessage); err != nil {
				return err
			}
		}
	}

	if o.SyslogFormatTimestampOverride != nil {

		// query param syslog.format.timestamp_override
		var qrSyslogFormatTimestampOverride string

		if o.SyslogFormatTimestampOverride != nil {
			qrSyslogFormatTimestampOverride = *o.SyslogFormatTimestampOverride
		}
		qSyslogFormatTimestampOverride := qrSyslogFormatTimestampOverride
		if qSyslogFormatTimestampOverride != "" {

			if err := r.SetQueryParam("syslog.format.timestamp_override", qSyslogFormatTimestampOverride); err != nil {
				return err
			}
		}
	}

	if o.SyslogPort != nil {

		// query param syslog.port
		var qrSyslogPort int64

		if o.SyslogPort != nil {
			qrSyslogPort = *o.SyslogPort
		}
		qSyslogPort := swag.FormatInt64(qrSyslogPort)
		if qSyslogPort != "" {

			if err := r.SetQueryParam("syslog.port", qSyslogPort); err != nil {
				return err
			}
		}
	}

	if o.SyslogTransport != nil {

		// query param syslog.transport
		var qrSyslogTransport string

		if o.SyslogTransport != nil {
			qrSyslogTransport = *o.SyslogTransport
		}
		qSyslogTransport := qrSyslogTransport
		if qSyslogTransport != "" {

			if err := r.SetQueryParam("syslog.transport", qSyslogTransport); err != nil {
				return err
			}
		}
	}

	if o.SystemDefined != nil {

		// query param system_defined
		var qrSystemDefined bool

		if o.SystemDefined != nil {
			qrSystemDefined = *o.SystemDefined
		}
		qSystemDefined := swag.FormatBool(qrSystemDefined)
		if qSystemDefined != "" {

			if err := r.SetQueryParam("system_defined", qSystemDefined); err != nil {
				return err
			}
		}
	}

	if o.Type != nil {

		// query param type
		var qrType string

		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamEmsDestinationCollectionGet binds the parameter fields
func (o *EmsDestinationCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamEmsDestinationCollectionGet binds the parameter order_by
func (o *EmsDestinationCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
