// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SvmDeleteReader is a Reader for the SvmDelete structure.
type SvmDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SvmDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSvmDeleteAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSvmDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSvmDeleteAccepted creates a SvmDeleteAccepted with default headers values
func NewSvmDeleteAccepted() *SvmDeleteAccepted {
	return &SvmDeleteAccepted{}
}

/*
SvmDeleteAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SvmDeleteAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this svm delete accepted response has a 2xx status code
func (o *SvmDeleteAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this svm delete accepted response has a 3xx status code
func (o *SvmDeleteAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this svm delete accepted response has a 4xx status code
func (o *SvmDeleteAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this svm delete accepted response has a 5xx status code
func (o *SvmDeleteAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this svm delete accepted response a status code equal to that given
func (o *SvmDeleteAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SvmDeleteAccepted) Error() string {
	return fmt.Sprintf("[DELETE /svm/svms/{uuid}][%d] svmDeleteAccepted  %+v", 202, o.Payload)
}

func (o *SvmDeleteAccepted) String() string {
	return fmt.Sprintf("[DELETE /svm/svms/{uuid}][%d] svmDeleteAccepted  %+v", 202, o.Payload)
}

func (o *SvmDeleteAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SvmDeleteAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSvmDeleteDefault creates a SvmDeleteDefault with default headers values
func NewSvmDeleteDefault(code int) *SvmDeleteDefault {
	return &SvmDeleteDefault{
		_statusCode: code,
	}
}

/*
	SvmDeleteDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

<br/>
```
| Error codes | Description |
| ----------- | ----------- |
| 13434894    | Maximum allowed SVM jobs exceeded. Wait and retry. |
```
<br/>
*/
type SvmDeleteDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the svm delete default response
func (o *SvmDeleteDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this svm delete default response has a 2xx status code
func (o *SvmDeleteDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this svm delete default response has a 3xx status code
func (o *SvmDeleteDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this svm delete default response has a 4xx status code
func (o *SvmDeleteDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this svm delete default response has a 5xx status code
func (o *SvmDeleteDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this svm delete default response a status code equal to that given
func (o *SvmDeleteDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SvmDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /svm/svms/{uuid}][%d] svm_delete default  %+v", o._statusCode, o.Payload)
}

func (o *SvmDeleteDefault) String() string {
	return fmt.Sprintf("[DELETE /svm/svms/{uuid}][%d] svm_delete default  %+v", o._statusCode, o.Payload)
}

func (o *SvmDeleteDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SvmDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
