// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SvmMigrationModifyReader is a Reader for the SvmMigrationModify structure.
type SvmMigrationModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SvmMigrationModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSvmMigrationModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSvmMigrationModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSvmMigrationModifyAccepted creates a SvmMigrationModifyAccepted with default headers values
func NewSvmMigrationModifyAccepted() *SvmMigrationModifyAccepted {
	return &SvmMigrationModifyAccepted{}
}

/*
SvmMigrationModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SvmMigrationModifyAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this svm migration modify accepted response has a 2xx status code
func (o *SvmMigrationModifyAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this svm migration modify accepted response has a 3xx status code
func (o *SvmMigrationModifyAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this svm migration modify accepted response has a 4xx status code
func (o *SvmMigrationModifyAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this svm migration modify accepted response has a 5xx status code
func (o *SvmMigrationModifyAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this svm migration modify accepted response a status code equal to that given
func (o *SvmMigrationModifyAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SvmMigrationModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /svm/migrations/{uuid}][%d] svmMigrationModifyAccepted  %+v", 202, o.Payload)
}

func (o *SvmMigrationModifyAccepted) String() string {
	return fmt.Sprintf("[PATCH /svm/migrations/{uuid}][%d] svmMigrationModifyAccepted  %+v", 202, o.Payload)
}

func (o *SvmMigrationModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SvmMigrationModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSvmMigrationModifyDefault creates a SvmMigrationModifyDefault with default headers values
func NewSvmMigrationModifyDefault(code int) *SvmMigrationModifyDefault {
	return &SvmMigrationModifyDefault{
		_statusCode: code,
	}
}

/*
	SvmMigrationModifyDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 13172783 | Migrate RDB lookup failed |
*/
type SvmMigrationModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the svm migration modify default response
func (o *SvmMigrationModifyDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this svm migration modify default response has a 2xx status code
func (o *SvmMigrationModifyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this svm migration modify default response has a 3xx status code
func (o *SvmMigrationModifyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this svm migration modify default response has a 4xx status code
func (o *SvmMigrationModifyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this svm migration modify default response has a 5xx status code
func (o *SvmMigrationModifyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this svm migration modify default response a status code equal to that given
func (o *SvmMigrationModifyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SvmMigrationModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /svm/migrations/{uuid}][%d] svm_migration_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SvmMigrationModifyDefault) String() string {
	return fmt.Sprintf("[PATCH /svm/migrations/{uuid}][%d] svm_migration_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SvmMigrationModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SvmMigrationModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
