// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// LocalCifsGroupMembers local cifs group members
//
// swagger:model local_cifs_group_members
type LocalCifsGroupMembers struct {

	// An array of local users, Active Directory users, and Active Directory groups specified to add or delete multiple members to or from a local group in a single API call.
	// Not allowed when the `name` property is used.
	//
	LocalCifsGroupMembersInlineRecords []*LocalCifsGroupMembersInlineRecordsInlineArrayItem `json:"records,omitempty"`

	// Local user, Active Directory user, or Active Directory group which is a member of the specified local group.
	//
	Name *string `json:"name,omitempty"`
}

// Validate validates this local cifs group members
func (m *LocalCifsGroupMembers) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLocalCifsGroupMembersInlineRecords(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LocalCifsGroupMembers) validateLocalCifsGroupMembersInlineRecords(formats strfmt.Registry) error {
	if swag.IsZero(m.LocalCifsGroupMembersInlineRecords) { // not required
		return nil
	}

	for i := 0; i < len(m.LocalCifsGroupMembersInlineRecords); i++ {
		if swag.IsZero(m.LocalCifsGroupMembersInlineRecords[i]) { // not required
			continue
		}

		if m.LocalCifsGroupMembersInlineRecords[i] != nil {
			if err := m.LocalCifsGroupMembersInlineRecords[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("records" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this local cifs group members based on the context it is used
func (m *LocalCifsGroupMembers) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLocalCifsGroupMembersInlineRecords(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LocalCifsGroupMembers) contextValidateLocalCifsGroupMembersInlineRecords(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.LocalCifsGroupMembersInlineRecords); i++ {

		if m.LocalCifsGroupMembersInlineRecords[i] != nil {
			if err := m.LocalCifsGroupMembersInlineRecords[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("records" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *LocalCifsGroupMembers) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *LocalCifsGroupMembers) UnmarshalBinary(b []byte) error {
	var res LocalCifsGroupMembers
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// LocalCifsGroupMembersInlineRecordsInlineArrayItem local cifs group members inline records inline array item
//
// swagger:model local_cifs_group_members_inline_records_inline_array_item
type LocalCifsGroupMembersInlineRecordsInlineArrayItem struct {

	// Local user, Active Directory user, or Active Directory group which is a member of the specified local group.
	//
	Name *string `json:"name,omitempty"`
}

// Validate validates this local cifs group members inline records inline array item
func (m *LocalCifsGroupMembersInlineRecordsInlineArrayItem) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this local cifs group members inline records inline array item based on context it is used
func (m *LocalCifsGroupMembersInlineRecordsInlineArrayItem) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *LocalCifsGroupMembersInlineRecordsInlineArrayItem) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *LocalCifsGroupMembersInlineRecordsInlineArrayItem) UnmarshalBinary(b []byte) error {
	var res LocalCifsGroupMembersInlineRecordsInlineArrayItem
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
